{
This file is part of Unreal Tournament System Config version 210f.

Copyright (C) 2000, 2003 Simon McVittie.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit AdminKnowledge;

interface

uses {BotSkinDefines,}Classes,SysUtils,Inifiles,Forms,Dialogs,UTSharedUtils1,
TModDetailsDefine,TBotModelDefine,TBotSkinDefine,TBotVoiceDefine{,unit1};

procedure ConvertKnowledge(Filename:string;Stream:TStream);
procedure WriteTerminatedString(x:string;Stream:TStream);


implementation

uses UTServerConfigGlobal,SvPackFiles,Knowledge;




{byte: number of voices  }

{?x: }


{END
next mod, or #0 for eof

}

procedure WriteTerminatedString(x:string;Stream:TStream);
var i:integer; c:char;
Begin
if x<>'' then
for i:=1 to length(x) do
  begin c:=x[i]; Stream.Write(c,1); end;
c:=#0;
Stream.Write(c,1);
End;

procedure ConvertKnowledge(Filename:string;Stream:TStream);
var FileReader:TIniFile;
    i,j,NumFaces,NumObjects:integer;
    b:byte;
    s,t:string;
Begin
  FileReader:=TIniFile.Create(filename);
    {IN EACH MOD BEGIN:            }
{null terminated string: Name}
s:=FileReader.ReadString(hMod,vModName,'(Unknown)');
WriteTerminatedString(s,Stream);
{nts:  Author}
s:=FileReader.ReadString(hMod,vAuthor,'(Anonymous)');
WriteTerminatedString(s,Stream);
{nts:  Email}
s:=FileReader.ReadString(hMod,vEmail,'');
WriteTerminatedString(s,Stream);
{nts:  WWW}
s:=FileReader.ReadString(hMod,vWWW,'');
WriteTerminatedString(s,Stream);
{nts:  OtherContact}
s:=FileReader.ReadString(hMod,vOtherContact,'');
WriteTerminatedString(s,Stream);
{nts:  Description}
s:=FileReader.ReadString(hMod,vModDesc,'');
WriteTerminatedString(s,Stream);
{int:  number of SPs}
NumObjects:=FileReader.ReadInteger(hSPs,vNumSPs,0);
Stream.Write(numObjects,4);
{?x nts: ServerPackage lines}
      for i:=1 to NumObjects do begin
        s:=FileReader.ReadString(hSPs,vSPPrefix+IntToStr(i),'');
        WriteTerminatedString(s,Stream);
        end;
{nts  TypeHeader}
s:=FileReader.ReadString(hMod,vTypeHeader,'');
WriteTerminatedString(s,Stream);
{nts DatafileCompilerName [use #13#0 for Psychic_313]}
s:=FileReader.ReadString(hHeader,vDatafileCompilerName,'Unknown');
if (s='') or (s='Psychic_313') then s:=#13;
WriteTerminatedString(s,Stream);

    {load up the models next}
    NumObjects:=FileReader.ReadInteger(hHeader,vNumModels,0);
    {int: number of models}
    Stream.Write(numObjects,4);
if (NumObjects>0) then
      for i:=1 to NumObjects do begin
      s:=hModelPrefix+IntToStr(i);
      {nts    BotClass:string;}
{nts    PlayerClass:string;}
{nts    SkinPackPrefix:string; }
{byte    (IsMale) + 128 if HasFaces true}
{nts    Desc:string;}
        t:=FileReader.ReadString(s,vModelBotClass,'');
        WriteTerminatedString(t,Stream);
        {would load player class here, so kludge it by doing bot again}
        WriteTerminatedString(t,Stream);
        t:=FileReader.ReadString(s,vModelMesh,'');
        WriteTerminatedString(t,Stream);
        b:=FileReader.ReadInteger(s,vModelIsMale,1) mod 128;
        if (FileReader.ReadInteger(s,vModelHasFaces,1)=1) then b:=b+128;
        Stream.Write(b,1);
        t:=FileReader.ReadString(s,vModelDesc,'');
        WriteTerminatedString(t,Stream);
      end;{for i}


    {now try loading skins, these go in a cache for now}
    {
int: number of skins       }
NumObjects:=FileReader.ReadInteger(hHeader,vNumSkins,0);
Stream.Write(numObjects,4);
    if (NumObjects>0) then
      for i:=1 to NumObjects do begin
        s:=hSkinPrefix+IntToStr(i);
        {nts    UTName:string;}
        t:=FileReader.ReadString(s,vSkinName,'');
        WriteTerminatedString(t,Stream);
        {nts    Desc:string;   }
        t:=FileReader.ReadString(s,vSkinDesc,'');
        WriteTerminatedString(t,Stream);
        {byte    IsTeamSkinnable:boolean; 0/255}
        b:=FileReader.ReadInteger(s,vSkinTeams,1) mod 256;
        Stream.Write(b,1);
        {int number of faces                   }
        {nts Face1                               }
        {nts FaceDesc1                            }
        {nts Face2                                 }
        {nts FaceDesc2                              }
        NumFaces:=FileReader.ReadInteger(s,vSkinNumFaces,0);
        Stream.Write(NumFaces,4);
        if (NumFaces>0) then
          for j:=1 to NumFaces do begin
            t:=FileReader.ReadString(s,vFacePrefix+IntToStr(j),'');
            WriteTerminatedString(t,Stream);
            t:=FileReader.ReadString(s,vFaceDescPrefix+IntToStr(j),t);
            WriteTerminatedString(t,Stream);
          end;{for j}
      end;{for i}

    {finally, do voices}
    NumObjects:=FileReader.ReadInteger(hHeader,vNumVoices,0);
    Stream.Write(numObjects,4);
    if (NumObjects>0) then
      for i:=1 to NumObjects do begin
        s:=hVoicePrefix+IntToStr(i);
        t:=FileReader.ReadString(s,vVoiceDesc,'');
        WriteTerminatedString(t,Stream);
        {nts     Desc:string;}
        {nts    VoiceClass:string;}
        {byte    VoiceType}
        t:=FileReader.ReadString(s,vVoiceClass,'');
        WriteTerminatedString(t,Stream);
        b:=FileReader.ReadInteger(s,vVoiceIsMale,1);
        Stream.Write(b,1);
      end;{for i}
End;

end.
