{
This file is part of Unreal Tournament System Config version 210f.

Copyright (C) 2000, 2003 Simon McVittie.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit TBotModelDefine;

interface

uses Classes,T313ObjectDefine,T313ListDefine,TBotSkinDefine,TBotVoiceDefine;

type

TBotModel = class(T313Object)
  public
    BotClass:string;        {Botpack.TSkaarjBot}
    PlayerClass:string;     {BotPack.TSkaarj - not in v1.0 datafiles}
    SkinPackPrefix:string;  {TSkM}
    IsMale:TUnrealTournVoiceType; {0 for female, 1 for male, 2 for Xan}
    HasFaces:boolean;
    Desc:string;
    Skins:TBotSkinList;
    constructor Create;
    destructor Destroy; override;
    function Clone:TBotModel;
  end;

TBotModelList = class(T313List)
  protected
    function GetData(Index:Integer):TBotModel;
    procedure SetData(index:integer;o:TBotModel);
  public
    property Items[Index:Integer]:TBotModel read GetData write SetData; default;
    {procedure Append(o:TBotModel);     }
    function Clone:TBotModelList;
  end;

implementation

constructor TBotModel.Create;
Begin
Skins:=TBotSkinList.Create;
End;

destructor TBotModel.Destroy;
Begin
  Skins.Free;
End;

function TBotModel.Clone:TBotModel;
Begin
  Result:=TBotModel.Create;
  Result.PlayerClass:=Self.PlayerClass;
  Result.BotClass:=Self.BotClass;
  Result.SkinpackPrefix:=Self.SkinPackPrefix;
  Result.IsMale:=Self.IsMale;
  Result.HasFaces:=Self.HasFaces;
  Result.Desc:=Self.Desc;
  {and the clever bit: }
  Result.Skins:=Self.Skins.Clone;
End;

function TBotModelList.GetData(index:integer):TBotModel;
Begin
  Result:=TBotModel(iPointers[index]^);
End;

procedure TBotModelList.SetData(index:integer;o:TBotModel);
Begin
  TBotModel(iPointers[index]^).Free;
  iPointers[index]:=@o;
End;


function TBotModelList.Clone:TBotModelList;
var i:integer;
Begin
Result:=TBotModelList.Create;
if Self.Count>0 then
  for i:=0 to Self.Count-1 do
    Result.Append(Self.Items[i].Clone);
End;

{procedure TBotModelList.Append(o:TBotModel);
Begin
  iPointers.Add(o);
End;                      }

end.
