{
This file is part of Unreal Tournament System Config version 210f.

Copyright (C) 2000, 2003 Simon McVittie.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit TBotSkinDefine;

interface

uses Classes,T313ObjectDefine,T313ListDefine;

type

TBotFace = record
  Face:string;
  Desc:string;
  end;

TBotSkin = class(T313Object)
  protected
    function GetBotFace(index:integer):TBotFace;
    procedure SetBotFace(index:integer;F:TBotFace);
    function GetBotFaceCount:integer;
  public
    UTName:string; {TSkMSkins.Warr}
    Desc:string;   {Arena Warrior}
    IsTeamSkinnable:boolean;
    Faces:TStringList;
    FaceDescs:TStringList;
    constructor Create;
    destructor Destroy; override;
    function Clone:TBotSkin;
    property BotFaces[index:integer]:TBotFace read GetBotFace write SetBotFace;
    property BotFacesCount:integer read GetBotFaceCount;
  end;

TBotSkinList = class(T313List)
  protected
    procedure SetData(index:integer;o:TBotSkin);
    function GetData(Index:Integer):TBotSkin;
  public
    function Clone:TBotSkinList;
    {procedure Append(o:TBotSkin); }
    property Items[Index:Integer]:TBotSkin read GetData write SetData; default;
  end;

implementation

function TBotSkin.GetBotFaceCount:integer;
Begin
 Result:=Faces.Count;
End;

constructor TBotSkin.Create;
Begin
  Faces:=TStringList.Create;
  FaceDescs:=TStringList.Create;
End;

destructor TBotSKin.Destroy;
Begin
  Faces.Free;
  FaceDescs.Free;
End;

procedure TBotSkin.SetBotFace(index:integer;F:TBotFace);
Begin
  Faces[index]:=F.Face;
  FaceDescs[index]:=F.Desc;
End;

function TBotSkin.GetBotFace(index:integer):TBotFace;
Begin
  Result.Face:=Faces[index];
  Result.Desc:=FaceDescs[index];
End;

function TBotSkin.Clone:TBotSkin;
Begin
  Result:=TBotSkin.Create;
  Result.UTName:=Self.UTName;
  Result.Desc:=Self.Desc;
  Result.IsTeamSkinnable:=Self.IsTeamSkinnable;
  Result.Faces.CommaText:=Self.Faces.CommaText;
  Result.FaceDescs.CommaText:=Self.FaceDescs.CommaText;
End;

function TBotSkinList.GetData(index:integer):TBotSkin;
Begin
  Result:=TBotSkin(self.iPointers[index]^);
End;

procedure TBotSkinList.SetData(index:integer;o:TBotSkin);
Begin
  TBotSkin(iPointers[index]^).Free;
  iPointers[index]:=@o;
End;


function TBotSkinList.Clone:TBotSkinList;
var i:integer;
Begin
Result:=TBotSkinList.Create;
if Self.Count>0 then
  for i:=0 to Self.Count-1 do
    Result.Append(Self.Items[i].Clone);
End;

{procedure TBotSkinList.Append(o:TBotSkin);
Begin
  iPointers.Add(o);
End;          }

end.
