{
This file is part of Unreal Tournament System Config version 210f.

Copyright (C) 2000, 2003 Simon McVittie.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

UNIT WeaponsPriorityFiles;

INTERFACE

Uses Classes;

function LoadWeapons(filename:string):TStringList;
procedure SaveWeapons(filename:string;UTWeapons,TheRest:TStrings);

IMPLEMENTATION

uses INIFiles,SysUtils;

const MaxWeaponPriority=49;
      Section='Engine.PlayerPawn';
      Prefix='WeaponPriority[';
      Suffix=']';
      None='None';
{Standard INI format.
Section = Engine.PlayerPawn
Key = WeaponPriority[0] to [49] as of UT 428

}

function LoadWeapons(filename:string):TStringList;
var Z:TIniFile;
    i:integer;
    s:string;
Begin
Result:=TStringList.Create;
Z:=TIniFile.Create(filename);
try
  for i:=0 to MaxWeaponPriority do
    begin
      s:=Prefix+IntToStr(i)+Suffix;
      s:=Z.ReadString(Section,s,None);
      if (s<>None) AND (s<>'') then Result.Append(s); 
    end;
finally
Z.Free;
end;{try}
End;

procedure SaveWeapons(filename:string;UTWeapons,TheRest:TStrings);
{NOTE: The two TStrings objects are in reverse order, so the highest priority
is index 0. UTWeapons has 14 items, 0-13, with 0 best and 13 worst. TheRest
has any number of items.}
var Z:TIniFile;
    i,j:integer;
    W:array[0..MaxWeaponPriority] of string;
Begin

  for i:=0 to MaxWeaponPriority do
    W[i]:='None';
  for i:=0 to 13 do                                     {@@@ HARD-CODED}
    if 13-i<UTWeapons.Count then W[i]:=UTWeapons[13-i];
  j:=MaxWeaponPriority; {last free weapon slot :. highest priority}
  i:=0;
  while (j>13) AND (i<TheRest.Count) do
    begin
      W[j]:=TheRest[i];
      inc(i);
      dec(j);
    end;{while}
Z:=TIniFile.Create(filename);
try
  for i:=0 to MaxWeaponPriority do
    Z.WriteString(Section,Prefix+IntToStr(i)+Suffix,W[i]);
finally
  Z.Free;
end;{try}
End;

END.
