{
This file is part of Unreal Tournament System Config version 210f.

Copyright (C) 2000, 2003 Simon McVittie.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

UNIT UTSharedUtils1;

INTERFACE

Uses TBotDefine,windows,shellapi,forms;


function ExecuteFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
function ReplaceChars(victim:string;searchFor:char;ReplaceWith:string):string;
function SpacesToUnderscores(victim:string):string;
function RemoveQuotes(victim:string):string;
function StartsWith(CompareString,Start:string):boolean;
function FloatVal(N:string):single;
function ByteVal(N:string):byte;
function SStr(X:single):string;
function BotDescString(victim:TBot):string;
function TextEqu(alpha,beta:string):boolean;

IMPLEMENTATION
Uses SysUtils;

function TextEqu(alpha,beta:string):boolean;
Begin
  Result:=(Uppercase(Alpha)=Uppercase(Beta));
End;

function ExecuteFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..259] of Char;
begin
  Result := ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), ShowCmd);
end;

function SpacesToUnderscores(victim:string):string;
{Converts ASCII tabs, control codes, spaces etc. to underscores}
var i:integer;
Begin
result:='';
  if (victim<>'') then
    for i:=1 to length(victim) do
    begin
      result:=result+victim[i];
      if (ord(result[i])<33)  then result[i]:='_';
    end;
End;

function ReplaceChars(victim:string;searchFor:char;ReplaceWith:string):string;
var i:integer;
Begin
result:='';
  if (victim<>'') then
    for i:=1 to length(victim) do
    begin
      if victim[i]=SearchFor
      then result:=result+replaceWith
      else result:=result+victim[i];
    end;
End;

function RemoveQuotes(victim:string):string;
Begin
result:=victim;
  if (length(result)>1) then
    if result[1]='"' then
      result:=copy(result,2,length(result)-2);
End;

function StartsWith(CompareString,Start:string):boolean;
Begin
  Result:=( (length(CompareString)>=length(Start)) AND
  (Copy(CompareString,1,length(Start))=Start)
  );
End;

function FloatVal(N:string):single;
var Err:integer;
Begin
  Val(N,Result,Err);
  if (Err<>0) then Result:=0;
End;

function ByteVal(N:string):byte;
var Err:integer;
Begin
  Val(N,Result,Err);
  if (Err<>0) then Result:=0;
End;

function SStr(X:single):string;
Begin
  Str(X:1:6,Result);
End;

function BotDescString(victim:TBot):string;
Begin
  Result:=victim.Name;
  case victim.Team of
    0: Result:=Result+' (Red ';
    1: Result:=Result+' (Blue ';
    2: Result:=Result+' (Green ';
    3: Result:=Result+' (Gold ';
  else Result:=Result+' (neutral ';
  end;{case}
  Result:=Result+victim.ModelClass+' / '+victim.Skin+')';
End;

END.
