{
This file is part of Unreal Tournament System Config version 210f.

Copyright (C) 2000, 2003 Simon McVittie.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit About;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls,Dialogs;

type

  THelpStuff = (helpContents,helpSPs,helpSPBrowser,helpMakeData,helpBotLib,
                helpBotExp,helpOptions,helpPriority,helpAbout);

  TAboutBox = class(TForm)
    Panel1: TPanel;
    ProductName: TLabel;
    Version: TLabel;
    OKButton: TButton;
    Label1: TLabel;
    Copyright: TLabel;
    Label2: TLabel;
    Comments: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    procedure GetHelp(topic:THelpStuff);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  AboutBox: TAboutBox;

const HelpHTML : array[helpContents..helpAbout] of string
               = ('help.htm','serverpackages.htm','serverpackages.htm',
                  'makedata.htm','botlib.htm','botlib.htm','options.htm',
                  'priority.htm',''{About: dummy entry});


implementation

uses UTSharedUtils1,UTServerConfigGlobal,Splashscreen, MainMenu,
  BotSaveWizard, Options, SvPack_Filter, SkinIntLoader, ModelIntLoader,
  VoiceINTLoader,HugeExporter;

{$R *.DFM}

procedure TAboutBox.GetHelp(topic:THelpStuff);
Begin
if topic = helpAbout then Self.ShowModal else
ExecuteFile(global.myfolder+'\'+HelpHTML[topic],'',global.MyFolder,SW_SHOW);
End;

procedure TAboutBox.FormCreate(Sender: TObject);
Begin
if ParamStr(1)='/export'
then begin
ShowMessage('Press OK to export UTSC210.DAT');
 ExportBigDatToFiles(ExtractFileDir(Application.ExeName)+'\UTSC210.dat',ExtractFileDir(Application.ExeName)+'\exports');
 ShowMessage('Export completed');
end;
with TUTSCSplashScreen.Create(Application) do begin
  try
  Repaint;
  Application.CreateForm(TMainMenuForm, MainMenuForm);
  Gauge.Progress:=10;
  UTServerConfigStartup;
    Gauge.Progress:=40;
  Application.CreateForm(TBotSaveWizardForm, BotSaveWizardForm);
  Gauge.Progress:=50;
  Application.CreateForm(TOptionsForm, OptionsForm);
    Gauge.Progress:=60;
  Application.CreateForm(TFilterForm, FilterForm);
    Gauge.Progress:=70;
  Application.CreateForm(TSkinIntLoaderForm, SkinIntLoaderForm);
    Gauge.Progress:=80;
  Application.CreateForm(TModelIntLoaderForm, ModelIntLoaderForm);
    Gauge.Progress:=90;
  Application.CreateForm(TVoiceINTLoaderForm, VoiceINTLoaderForm);
    Gauge.Progress:=100;
  
  finally
  Free;
  end;{try}
end;
End;

end.

