{
This file is part of Unreal Tournament System Config version 210f.

Copyright (C) 2000, 2003 Simon McVittie.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit BotSaveWizard;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, TBigKegOBotsDefine, ComCtrls, checklst;

type
  TBotSaveWizardForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label1: TLabel;
    spPage: TTabSheet;
    spRemNonSPackBtn: TBitBtn;
    txtActionComboBox: TComboBox;
    Label2: TLabel;
    txtFieldComboBox: TComboBox;
    txtComparisonComboBox: TComboBox;
    txtTextEdit: TEdit;
    txtCommitBtn: TBitBtn;
    nmActionCombobox: TComboBox;
    Label4: TLabel;
    nmFieldCombobox: TComboBox;
    nmComparisonComboBox: TComboBox;
    nmCommitBtn: TBitBtn;
    nmThresholdScrollBar: TScrollBar;
    Label5: TLabel;
    nmThresholdDummyEdit: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    TabSheet4: TTabSheet;
    tmActionCombobox: TComboBox;
    Label9: TLabel;
    tmCommitBtn: TBitBtn;
    tmTeamComboBox: TComboBox;
    jbActionCombobox: TComboBox;
    Label10: TLabel;
    jbConditionComboBox: TComboBox;
    jbCommitBtn: TBitBtn;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    txtCaseSensCheckBox: TCheckBox;
    Label3: TLabel;
    BotsChecklist: TCheckListBox;
    Label13: TLabel;
    Label14: TLabel;
    procedure spRemNonSPackBtnClick(Sender: TObject);
    procedure txtCommitBtnClick(Sender: TObject);
    procedure nmCommitBtnClick(Sender: TObject);
    procedure tmCommitBtnClick(Sender: TObject);
    procedure jbCommitBtnClick(Sender: TObject);
    procedure nmThresholdScrollBarChange(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure nmFieldComboboxChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  BotSaveWizardForm: TBotSaveWizardForm;
  TheExportBotList:TBigKegOBots;

implementation
uses UTSharedUtils1,BotFiles,{MdiChildBotLib,}SvPackFiles,UTServerConfigGlobal;

{$R *.DFM}

procedure TBotSaveWizardForm.spRemNonSPackBtnClick(Sender: TObject);
{|--Nested function}
{|} (*function locPackageName(UTResource:string):string;[no longer needed, use]
{|} Begin                                               [ExtractPackageName() ]
{|} if (Pos('.',UTResource)=0) then Result:=''
{|} else Result:=Copy(UTResource,1,Pos('.',UTResource)-1);
{|} End;*)
{|}
{|} function IsInSPack(SPack:TStringList;Content:string):boolean;
{|} var uc:TStringList;
{|} Begin
{|} uc:=TStringList.Create;
{|} Result:=FALSE;
{|} try
{|} uc.Text:=UpperCase(SPack.Text);
{|} Result:=(uc.IndexOf(UpperCase(Content))>0 ) OR (Content='');
{|} finally
{|} uc.Free;
{|} end;{try/finally}
{|} End;
{|--}
var SP:TStringList;
    i:integer;
    f:string;
Begin
SP:=TStringList.Create;
try
f:=Global.UTSysIni;
if FileExists(f) then begin
LoadServerPackages(SP,f);
if (BotsChecklist.Items.Count>0) then begin
  for i:=0 to BotsChecklist.Items.Count-1 do begin
    if NOT (
    (IsInSPack(SP,ExtractPackageName(TheExportBotList[i].ModelClass)))
    AND (IsInSPack(SP,ExtractPackageName(TheExportBotList[i].Face)))
    AND (IsInSPack(SP,ExtractPackageName(TheExportBotList[i].Skin)))
    AND (IsInSPack(SP,ExtractPackageName(TheExportBotList[i].Voice)))
    )
    then BotsChecklist.Checked[i]:=FALSE;
  end;{for}
end;{if count>0}
end;{if fileexists}
finally
SP.Free;
end;{try}
End;


procedure TBotSaveWizardForm.txtCommitBtnClick(Sender: TObject);
var i:integer;
{- Nested functions}
{|}   function MaybeUC(s:string):string;
{|}   begin
{|}     if txtCaseSensCheckbox.Checked then Result:=s else Result:=UpperCase(s);
{|}   end;{sub-fn}
{|}
{|}   function MeetsCriteria(list:TBigKegOBots;index:integer):boolean;
{|}   var key:string;
{|}   begin
{|}     case txtFieldCombobox.ItemIndex of
{|}       0: key:=list.Data[index].Name;
{|}       1: key:=list.Data[index].ModelClass;
{|}       2: key:=list.Data[index].Skin;
{|}       3: key:=list.Data[index].Face;
{|}       4: key:=list.Data[index].Voice;
{|}       else key:=list.Data[index].FavoriteWeapon;
{|}     end;{case}
{|}     case txtComparisonComboBox.ItemIndex of
{|}       0: Result:=(MaybeUC(key)=MaybeUC(txtTextEdit.text));              {is}
{|}       2: Result:=(Pos(MaybeUC(txtTextEdit.text),MaybeUC(key))=0);  {not include}
{|}       3: Result:=StartsWith(MaybeUC(key),MaybeUC(txtTextEdit.text));    {starts with}
{|}       else
{|}         Result:=(Pos(MaybeUC(txtTextEdit.text),MaybeUC(key))<>0);  {include (default)}
{|}     end;{case}
{|}   end;{sub-fn}
{- end of nested functions}
Begin
if (TheExportBotList.Count>0) then
  for i:=TheExportBotList.Count-1 downto 0 do
    if MeetsCriteria(TheExportBotList,i)
      then BotsCheckList.Checked[i]:= (txtActionCombobox.ItemIndex=0);
End;

procedure TBotSaveWizardForm.nmCommitBtnClick(Sender: TObject);
var threshold:single;
    i:integer;
{- Nested function}
{|}   function MeetsCriteria(list:TBigKegOBots;index:integer):boolean;
{|}   var key:single;
{|}   begin
{|}     case nmFieldCombobox.ItemIndex of
{|}       0: key:=list.Data[index].CombatStyle;
{|}       1: key:=list.Data[index].StrafingAbility;
{|}       2: key:=list.Data[index].Alertness;
{|}       3: key:=list.Data[index].Camping;
{|}       4: key:=list.Data[index].Accuracy;
{|}       else key:=list.Data[index].Skill;
{|}     end;{case}
{|}     case nmComparisonComboBox.ItemIndex of
{|}       0:{is less than}               Result:=(key<threshold);
{|}       1:{is less than or equal to}   Result:=(key<=Threshold);
{|}       2:{is exactly equal to}        Result:=(key=Threshold);
{|}       3:{is greater than or equal to}Result:=(key>=Threshold);
{|}       else {is greater than}         Result:=(key>Threshold);
{|}     end;{case}
{|}   end;{sub-fn}
{- end of nested functions}
Begin
if (nmFieldCombobox.ItemIndex=0)
   then threshold:=nmThresholdScrollbar.position/2
   else threshold:=nmThresholdScrollBar.Position/20;
if (TheExportBotList.Count>0) then
  for i:=TheExportBotList.Count-1 downto 0 do
    if MeetsCriteria(TheExportBotList,i)
      then BotsCheckList.Checked[i]:= (nmActionCombobox.ItemIndex=0);
end;

procedure TBotSaveWizardForm.tmCommitBtnClick(Sender: TObject);
var IWant:byte;i:integer;
begin
if (tmTeamCombobox.ItemIndex=4)
  then IWant:=255
  else IWant:=tmTeamCombobox.ItemIndex;
if (TheExportBotList.Count>0) then
  for i:=TheExportBotList.Count-1 downto 0 do
    if (TheExportBotList[i].Team=IWant)
      then BotsCheckList.Checked[i]:= (tmActionCombobox.ItemIndex=0);
end;

procedure TBotSaveWizardForm.jbCommitBtnClick(Sender: TObject);
var IWant:boolean;i:integer;
begin
IWant:=(jbConditionComboBox.ItemIndex=0);
if (TheExportBotList.Count>0) then
  for i:=TheExportBotList.Count-1 downto 0 do
    if (TheExportBotList[i].Jumpy=IWant)
      then BotsCheckList.Checked[i]:= (tmActionCombobox.ItemIndex=0);
end;

procedure TBotSaveWizardForm.nmThresholdScrollBarChange(Sender: TObject);
begin
if (nmFieldComboBox.ItemIndex=0)
  then nmThresholdDummyEdit.Text:=SStr(nmThresholdScrollBar.Position/2)
  else nmThresholdDummyEdit.Text:=SStr(nmThresholdScrollBar.Position/20);
end;

procedure TBotSaveWizardForm.OKBtnClick(Sender: TObject);
var i:integer;f:string;
Begin
if (BotsChecklist.Items.Count>0) then begin
  f:=Global.UTUserIni;
  if FileExists(f) then begin
    {remove unused bots}
    for i:=TheExportBotList.Count-1 downto 0 do
      if not BotsChecklist.Checked[i] then begin
                           {ShowMessage('Deleted '+TheExportBotList.Data[i].name);}
                           TheExportBotlist.Delete(i);
                           end;
    {use the rest}
    ExportBotList(Pick32Bots(TheExportBotList),f);
    ModalResult:=mrOK;
  end;{if}
end;{if}
End;

procedure TBotSaveWizardForm.nmFieldComboboxChange(Sender: TObject);
begin
  if (nmFieldComboBox.ItemIndex=0) then
  begin
    nmThresholdScrollbar.Max:=2;
    nmThresholdScrollbar.Min:=-2;
    nmThresholdScrollbar.Position:=0;
  end else begin
    nmThresholdScrollbar.Max:=20;
    nmThresholdScrollbar.Min:=-20;
    nmThresholdScrollbar.Position:=0;
  end;
end;

INITIALIZATION
TheExportBotList:=TBigKegOBots.Create;
TheExportBotList.Init;

FINALIZATION
TheExportBotList.Free;

END.
