{
This file is part of Unreal Tournament System Config version 210f.

Copyright (C) 2000, 2003 Simon McVittie.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit DatafileMaker;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Buttons, TBotModelDefine, TBotSkinDefine,
  TBotVoiceDefine, Menus;

type
  TDatafileWizard = class(TForm)
    PageControl1: TPageControl;
    MakerDetails: TTabSheet;
    ServerPackages: TTabSheet;
    Label2: TLabel;
    ModAuthorEdit: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    EmailEdit: TEdit;
    Label5: TLabel;
    WWWEdit: TEdit;
    Label6: TLabel;
    AltContactEdit: TEdit;
    BitBtn1: TBitBtn;
    ModDetails: TTabSheet;
    Label7: TLabel;
    Label8: TLabel;
    ModNameEdit: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    BitBtn2: TBitBtn;
    ModDescMemo: TMemo;
    ModCategoryComboBox: TComboBox;
    Label11: TLabel;
    BitBtn3: TBitBtn;
    ServerPackagesMemo: TMemo;
    Label12: TLabel;
    Models: TTabSheet;
    Label13: TLabel;
    BitBtn4: TBitBtn;
    ModelListBox: TListBox;
    GroupBox1: TGroupBox;
    AddModelBtn: TBitBtn;
    ModelDescEdit: TEdit;
    Label14: TLabel;
    Label15: TLabel;
    ModelBotClassEdit: TEdit;
    Label16: TLabel;
    ModelMeshEdit: TEdit;
    Label17: TLabel;
    ModelVoicetypeComboBox: TComboBox;
    ModelFacesCheckBox: TCheckBox;
    Skins: TTabSheet;
    Label18: TLabel;
    SkinListBox: TListBox;
    AddSkinBtn: TBitBtn;
    BitBtn9: TBitBtn;
    GroupBox2: TGroupBox;
    Label19: TLabel;
    Label20: TLabel;
    SkinDescEdit: TEdit;
    SkinClassEdit: TEdit;
    TeamSkinsCheckBox: TCheckBox;
    FacesMemo: TMemo;
    Label21: TLabel;
    FaceDescsMemo: TMemo;
    Label22: TLabel;
    Voices: TTabSheet;
    Label23: TLabel;
    VoiceListBox: TListBox;
    AddVoiceBtn: TBitBtn;
    BitBtn12: TBitBtn;
    GroupBox3: TGroupBox;
    Label25: TLabel;
    Label27: TLabel;
    VoiceDescEdit: TEdit;
    VoiceTypeComboBox: TComboBox;
    Label24: TLabel;
    VoiceClassEdit: TEdit;
    Finish: TTabSheet;
    Label26: TLabel;
    NumModelsLabel: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    NumSkinsLabel: TLabel;
    Label31: TLabel;
    NumVoicesLabel: TLabel;
    Label30: TLabel;
    NumSPsLabel: TLabel;
    ModSummaryLabel: TLabel;
    SaveModAsEdit: TEdit;
    Label32: TLabel;
    FinishBtn: TBitBtn;
    Label33: TLabel;
    BitBtn6: TBitBtn;
    Label34: TLabel;
    BitBtn7: TBitBtn;
    Label35: TLabel;
    OpenDialog1: TOpenDialog;
    DelMdlBtn: TBitBtn;
    ImportHlpBtn: TBitBtn;
    Label36: TLabel;
    AddIntMdlBtn: TBitBtn;
    DelSkinBtn: TBitBtn;
    AddSkinIntBtn: TBitBtn;
    DelVoxBtn: TBitBtn;
    Label37: TLabel;
    CompilerNameEdit: TEdit;
    MainMenu1: TMainMenu;
    Help1: TMenuItem;
    AboutUTSC1: TMenuItem;
    Contents1: TMenuItem;
    N1: TMenuItem;
    Contextsensitivehelp1: TMenuItem;
    Panel1: TPanel;
    Label1: TLabel;
    AbortBtn: TBitBtn;
    AddVoiceINTBtn: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure FinishBtnClick(Sender: TObject);
    procedure SaveModAsEditChange(Sender: TObject);
    procedure CreateNew;
    procedure LoadExisting(Filename:string);
    procedure AbortBtnClick(Sender: TObject);
    procedure ModelListBoxClick(Sender: TObject);
    procedure ModelStuffChange(Sender: TObject);
    procedure AddModelBtnClick(Sender: TObject);
    procedure SkinListBoxClick(Sender: TObject);
    procedure SkinStuffChange(Sender: TObject);
    procedure AddSkinBtnClick(Sender: TObject);
    procedure VoiceStuffChange(Sender: TObject);
    procedure VoiceListBoxClick(Sender: TObject);
    procedure AddVoiceBtnClick(Sender: TObject);
    procedure ServerPackagesMemoChange(Sender: TObject);
    procedure ModAuthorEditChange(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure BitBtn7Click(Sender: TObject);
    procedure DelMdlBtnClick(Sender: TObject);
    procedure AddIntMdlBtnClick(Sender: TObject);
    procedure DelSkinBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DelVoxBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn6Click(Sender: TObject);
    procedure AddSkinIntBtnClick(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure AboutUTSC1Click(Sender: TObject);
    procedure Contextsensitivehelp1Click(Sender: TObject);
    procedure ModDescMemoChange(Sender: TObject);
    procedure AddVoiceINTBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    CacheModels: TBotModelList;
    CacheSkins: TBotSkinList;
    CacheVoices: TBotVoiceList;
{    CacheVoices_IsMale: TStringList;}
    IHaveFinished:boolean;
    CurrentFilename:string;
    Editing:boolean;
    { Public declarations }
  end;

{var
  DatafileWizard: TDatafileWizard;}

implementation

uses Inifiles,FileCtrl,Knowledge,ModelIntLoader,SkinINTLoader,About,
  VoiceINTLoader,MainMenu;

const
  strUntitled = '<new datafile>';
  strEditingPrefix = 'Editing ';
  strCaptionSuffix = ' - Datafile Creator';

{$R *.DFM}

procedure TDatafileWizard.BitBtn1Click(Sender: TObject);
begin
  PageControl1.SelectNextPage(TRUE);
end;

procedure TDatafileWizard.FinishBtnClick(Sender: TObject);
const
hAbout='AboutThisFile';
aboutA='';
aboutB=' This is a datafile for Unreal Tournament System Config v2.1 by Psychic_313.';
aboutC=' This application is available from Paradox Productions:';
aboutD=' <http://www.pseudorandom.co.uk/2000/paradox/utsc/>.';
aboutE='';
aboutF=' The rest of this file is intended to be read by UT System Config.';
aboutG='';
aboutH='';
aboutI='';
aboutZ='--------------------------------------------------------------------------------------------------';
var Tau:TIniFile; i,j,k:integer; s,t,filename:string; breakout:boolean;
begin
breakout:=FALSE;

{finish and save to file}

filename:=CurrentFilename;


if FileExists(Filename)
AND (MessageDlg('File exists. Overwrite?',mtConfirmation,[mbYes,mbNo],0)=mrNo) then breakout:=TRUE;

if not BreakOut then begin
Tau:=TIniFile.Create(Filename);

Tau.WriteString(hAbout,'a',aboutA);
Tau.WriteString(hAbout,'b',aboutB);
Tau.WriteString(hAbout,'c',aboutC);
Tau.WriteString(hAbout,'d',aboutD);
Tau.WriteString(hAbout,'e',aboutE);
Tau.WriteString(hAbout,'f',aboutF);
Tau.WriteString(hAbout,'g',aboutG);
Tau.WriteString(hAbout,'h',aboutH);
Tau.WriteString(hAbout,'i',aboutI);
Tau.WriteString(hAbout,'z',aboutZ);


Tau.WriteInteger(hHeader,vWriter,MyVersion);
Tau.WriteInteger(hHeader,vFormat,OldestVersionWhichCanReadMyFileFormat);
Tau.WriteInteger(hHeader,vNumModels,ModelListBox.Items.Count);
Tau.WriteInteger(hHeader,vNumSkins,SkinListBox.Items.Count);
Tau.WriteInteger(hHeader,vNumVoices,VoiceListBox.Items.Count);
Tau.WriteString(hHeader,vDatafileCompilerName,CompilerNameEdit.Text);

Tau.WriteString(hMod,vModName,ModNameEdit.Text);
Tau.WriteString(hMod,vAuthor,ModAuthorEdit.Text);
Tau.WriteString(hMod,vEmail,EmailEdit.Text);
Tau.WriteString(hMod,vWWW,WWWEdit.Text);
Tau.WriteString(hMod,vOtherContact,AltContactEdit.text);
Tau.WriteString(hMod,vModDesc,ModDescMemo.Lines.Text);
Tau.WriteString(hMod,vTypeHeader,ModCategoryCombobox.Items[ModCategoryCombobox.ItemIndex]);

Tau.WriteString(hSPs,vNumSPs,IntToStr(ServerPackagesMemo.Lines.Count));
if ServerPackagesMemo.Lines.Count>0 then
for i:=1 to ServerPackagesMemo.Lines.Count do
begin
  Tau.WriteString(hSPs,vSPPrefix+IntToStr(i),ServerPackagesMemo.Lines[i-1]);
end;{if/for}

if ModelListBox.Items.Count>0 then
for i:=1 to ModelListBox.Items.Count do
begin
  s:=hModelPrefix+IntToStr(i);
  Tau.WriteString(s,vModelBotClass,CacheModels[i-1].BotClass);
  Tau.WriteString(s,vModelMesh,CacheModels[i-1].SkinPackPrefix);
  Tau.WriteString(s,vModelDesc,CacheModels[i-1].Desc);
  Tau.WriteInteger(s,vModelIsMale,CacheModels[i-1].IsMale);
  if CacheModels[i-1].HasFaces
    then Tau.WriteInteger(s,vModelHasFaces,1)
    else Tau.WriteInteger(s,vModelHasFaces,0);
end;{if/for}

if SkinListBox.Items.Count>0 then
for i:=1 to SkinListBox.Items.Count do
begin
  s:=hSkinPrefix+IntToStr(i);
  Tau.WriteString(s,vSkinName,CacheSkins[i-1].UTName);
  Tau.WriteString(s,vSkinDesc,CacheSkins[i-1].Desc);
  if CacheSkins[i-1].IsTeamSkinnable
    then Tau.WriteInteger(s,vSkinTeams,1)
    else Tau.WriteInteger(s,vSkinTeams,0);
  j:=CacheSkins[i-1].BotFacesCount;
  Tau.WriteInteger(s,vSkinNumFaces,j);
  if (j>0) then for k:=1 to j do
  begin
    t:=IntToStr(k);
    Tau.WriteString(s,vFacePrefix+t,CacheSkins[i-1].BotFaces[k-1].Face);
    Tau.WriteString(s,vFaceDescPrefix+t,CacheSkins[i-1].BotFaces[k-1].Desc);
  end;{if/for}
end;{if/for}

if VoiceListBox.Items.Count>0 then
for i:=1 to VoiceListBox.Items.Count do
begin
  s:=hVoicePrefix+IntToStr(i);
  Tau.WriteString(s,vVoiceDesc,CacheVoices[i-1].Desc);
  Tau.WriteString(s,vVoiceClass,CacheVoices[i-1].VoiceClass);
  Tau.WriteString(s,vVoiceIsMale,IntToStr(CacheVoices[i-1].VoiceType));
end;{if/for}

IHaveFinished:=TRUE;
Tau.Free;
Self.close;
end;{if not breakout}

MainMenuForm.InformChangedKnowledge;

end;

procedure TDatafileWizard.SaveModAsEditChange(Sender: TObject);
const ControlChars = [#0..#31];
      ReservedChars = ['\','|','/','?','*','"',':','<','>'];
      IllegalChars = ControlChars + ReservedChars;
var i,j,k:integer; s:string;
Begin                             
  if (SaveModAsEdit.Tag=0) then begin
    SaveModAsEdit.Tag:=1;
    if length(SaveModAsEdit.Text)>0 then begin
      s:=SaveModAsEdit.Text;
      j:=SaveModAsEdit.SelStart;
      k:=SaveModAsEdit.SelLength;
      for i:=1 to length(s) do
        if s[i] in IllegalChars then s[i]:='_';
      SaveModAsEdit.Text:=s;
      SaveModAsEdit.SelStart:=j;
      SaveModAsEdit.SelLength:=k;
    end;{if}
    SaveModAsEdit.Tag:=0;
    if SaveModAsEdit.Text='' then begin
      CurrentFilename:='';
    end else begin
      CurrentFilename:=
        ExtractFilePath(Application.ExeName)+'\'+SaveModAsEdit.Text+'.utsc.txt';
    end;{else}
  end;{if}
End;

procedure TDatafileWizard.CreateNew;
begin
  Editing:=FALSE;
  Caption:=strUntitled+strCaptionSuffix;
  IHaveFinished:=FALSE;
  CurrentFilename:='';

  ModAuthorEdit.Text:='unknown';
  EmailEdit.Text:='';
  WWWEdit.Text:='';
  AltContactEdit.Text:='';

  ModNameEdit.Text:='';
  ModCategoryComboBox.ItemIndex:=0;
  ModDescMemo.Lines.Clear;

  ServerPackagesMemo.Lines.Clear;

  ModelListBox.Items.Clear;
  ModelDescEdit.Text:='';
  ModelBotClassEdit.Text:='';
  ModelMeshEdit.Text:='';
  ModelVoicetypeComboBox.ItemIndex:=1;
  ModelFacesCheckbox.Checked:=TRUE;
  ModelDescEdit.Enabled:=FALSE;
  ModelBotClassEdit.Enabled:=FALSE;
  ModelMeshEdit.Enabled:=FALSE;
  ModelVoicetypeComboBox.Enabled:=FALSE;
  ModelFacesCheckbox.Enabled:=FALSE;

  SkinListBox.Items.Clear;
  SkinDescEdit.Text:='';
  SkinClassEdit.Text:='';
  FacesMemo.Lines.Clear;
  FaceDescsMemo.Lines.Clear;
  TeamSkinsCheckBox.Checked:=TRUE;
  SkinDescEdit.Enabled:=FALSE;
  SkinClassEdit.Enabled:=FALSE;
  FacesMemo.Enabled:=FALSE;
  FaceDescsMemo.Enabled:=FALSE;
  TeamSkinsCheckBox.Enabled:=FALSE;

  VoiceListBox.Items.Clear;
  VoiceClassEdit.Text:='';
  VoiceDescEdit.Text:='';
  VoiceTypeCombobox.ItemIndex:=1;
  VoiceClassEdit.Enabled:=FALSE;
  VoiceDescEdit.Enabled:=FALSE;
  VoiceTypeCombobox.Enabled:=FALSE;

  ModSummaryLabel.Caption:='';
  NumSPsLabel.Caption:='0';
  NumModelsLabel.Caption:='0';
  NumSkinsLabel.Caption:='0';
  NumVoicesLabel.Caption:='0';

  SaveModAsEdit.Text:='';

  CacheModels.Clear;
  CacheSkins.Clear;
  CacheVoices.Clear;
  PageControl1.ActivePage:=MakerDetails;
end;

procedure TDatafileWizard.LoadExisting(Filename:string);
var Ini:TIniFile;
    i,j,numObjects,numFaces:integer;
    s,t:string;
    NewSkin:TBotSkin;
    NewMdl:TBotModel;
    NewVoice:TBotVoice;
    b:boolean;
begin
Editing:=TRUE;
SaveModAsEdit.Tag:=1;

IHaveFinished:=FALSE;
CurrentFilename:=Filename;
Caption:=strEditingPrefix+ExtractFileName(Filename)+' - Datafile Creator';
ModSummaryLabel.Caption:='';
NumSPsLabel.Caption:='0';
NumModelsLabel.Caption:='0';
NumSkinsLabel.Caption:='0';
NumVoicesLabel.Caption:='0';

Ini:=TIniFile.Create(Filename);
try
  ModAuthorEdit.Text:=Ini.ReadString(hMod,vAuthor,'');
  EmailEdit.Text:=Ini.ReadString(hMod,vEmail,'');
  WWWEdit.Text:=Ini.ReadString(hMod,vWWW,'');
  AltContactEdit.Text:=Ini.ReadString(hMod,vOtherContact,'');

  ModNameEdit.Text:=Ini.ReadString(hMod,vModname,'');
  ModCategoryComboBox.ItemIndex:=ModCategoryComboBox.Items.IndexOf(
                                   Ini.ReadString(hMod,vTypeHeader,'Mutator') );
  if (ModCategoryCombobox.ItemIndex=-1) then ModCategoryCombobox.ItemIndex:=0;

  ModDescMemo.Lines.Clear;
  ModDescMemo.Lines.Text:=Ini.ReadString(hMod,vModDesc,'');

  ServerPackagesMemo.Lines.Clear;
  NumObjects:=Ini.ReadInteger(hSPs,vNumSPs,0);
    if (NumObjects>0) then
      for i:=1 to NumObjects do begin
        s:=Ini.ReadString(hSPs,vSPPrefix+IntToStr(i),'');
        if (s<>'') then ServerPackagesMemo.Lines.Append(s);
      end;{for}
  NumSPsLabel.Caption:=IntToStr(ServerPackagesMemo.Lines.Count);


      {======= BOT STUFF =========}

  CacheModels.Clear;
  ModelListBox.Items.Clear;
  ModelDescEdit.Text:='';
  ModelBotClassEdit.Text:='';
  ModelMeshEdit.Text:='';
  ModelVoicetypeComboBox.ItemIndex:=1;
  ModelFacesCheckbox.Checked:=TRUE;
    {load up the models next}
    NumObjects:=Ini.ReadInteger(hHeader,vNumModels,0);
    if (NumObjects>0) then
      for i:=1 to NumObjects do begin
        s:=hModelPrefix+IntToStr(i);
        {get the model}
           NewMdl:=TBotModel.Create;
           NewMdl.BotClass:=Ini.ReadString(s,vModelBotClass,'');
           NewMdl.SkinPackPrefix:=Ini.ReadString(s,vModelMesh,'');
           NewMdl.HasFaces:=(Ini.ReadInteger(s,vModelHasFaces,1)=1);
           NewMdl.IsMale:=Ini.ReadInteger(s,vModelIsMale,1);
           NewMdl.Desc:=Ini.ReadString(s,vModelDesc,NewMdl.BotClass);
        {add it to the list}
          CacheModels.Append(NewMdl);
          ModelListBox.Items.Append('My Model');
          ModelListBox.ItemIndex:=ModelListBox.Items.Count-1;
          ModelListBoxClick(self);
          ModelStuffChange(self);
          NumModelsLabel.Caption:=IntToStr(ModelListBox.Items.Count);

      end;{for i}
  b:=(ModelListbox.Items.Count>0);
  ModelDescEdit.Enabled:=b;
  ModelBotClassEdit.Enabled:=b;
  ModelMeshEdit.Enabled:=b;
  ModelVoicetypeComboBox.Enabled:=b;
  ModelFacesCheckbox.Enabled:=b;

  CacheSkins.Clear;
  SkinListBox.Items.Clear;
  SkinDescEdit.Text:='';
  SkinClassEdit.Text:='';
  FacesMemo.Lines.Clear;
  FaceDescsMemo.Lines.Clear;
  TeamSkinsCheckBox.Checked:=TRUE;

    NumObjects:=Ini.ReadInteger(hHeader,vNumSkins,0);
    if (NumObjects>0) then
      for i:=1 to NumObjects do begin
        s:=hSkinPrefix+IntToStr(i);
        NewSkin:=TBotSkin.Create;
        NewSkin.UTName:=Ini.ReadString(s,vSkinName,'');
        NewSkin.IsTeamSkinnable:=(Ini.ReadInteger(s,vSkinTeams,1)=1);
        NewSkin.Desc:=Ini.ReadString(s,vSkinDesc,NewSkin.UTName);

        NumFaces:=Ini.ReadInteger(s,vSkinNumFaces,0);
        if (NumFaces>0) then
          for j:=1 to NumFaces do begin
            t:=Ini.ReadString(s,vFacePrefix+IntToStr(j),'');
            if (t<>'') then begin
              NewSkin.Faces.Append(t);
              NewSkin.FaceDescs.Append(Ini.ReadString(s,vFaceDescPrefix+IntToStr(j),t));
            end;{if}
          end;{for j}
        CacheSkins.Append(NewSkin);
        SkinListBox.Items.Append('My Skin');
        SkinListBox.ItemIndex:=SkinListBox.Items.Count-1;
        SkinListBoxClick(self);
        SkinStuffChange(Self);
        NumSkinsLabel.Caption:=IntToStr(SkinListBox.Items.Count)
      end;{for i}


  {finally, do voices}

  CacheVoices.Clear;

  VoiceListBox.Items.Clear;
  VoiceClassEdit.Text:='';
  VoiceDescEdit.Text:='';
  VoiceTypeCombobox.ItemIndex:=1;

    NumObjects:=Ini.ReadInteger(hHeader,vNumVoices,0);
    if (NumObjects>0) then
      for i:=1 to NumObjects do begin
        s:=hVoicePrefix+IntToStr(i);
        NewVoice:=TBotVoice.Create;
        NewVoice.VoiceClass:=Ini.ReadString(s,vVoiceClass,'');
        NewVoice.VoiceType:=Ini.ReadInteger(s,vVoiceIsMale,1);
        NewVoice.Desc:=Ini.ReadString(s,vVoiceDesc,NewVoice.VoiceClass);
        CacheVoices.Append(NewVoice);
        VoiceListBox.Items.Append('My Voice');
        VoiceListBox.ItemIndex:=VoiceListBox.Items.Count-1;
        VoiceListBoxClick(self);
        VoiceStuffChange(Self);
        NumVoicesLabel.Caption:=IntToStr(VoiceListBox.Items.Count)
      end;{for i}
  b:=(VoiceListbox.Items.Count>0);
  VoiceClassEdit.Enabled:=b;
  VoiceDescEdit.Enabled:=b;
  VoiceTypeCombobox.Enabled:=b;

  
  s:=ExtractFileName(CurrentFilename);
  {ShowMessage('s='+s);}
  s:=Copy(s,1,length(s)-9);
  {ShowMessage('s='+s);}
  SaveModAsEdit.Text:=s;
  SaveModAsEdit.Tag:=0;
  PageControl1.ActivePage:=MakerDetails;

finally
Ini.Free;
end;{try}
end;

procedure TDatafileWizard.AbortBtnClick(Sender: TObject);
begin
    Self.Close;
end;

procedure TDatafileWizard.ModelListBoxClick(Sender: TObject);
begin
  if (ModelListBox.Tag=0) AND (ModelListBox.ItemIndex>-1) then
  begin
    ModelListBox.Tag:=1;
    ModelDescEdit.Text:=CacheModels[ModelListBox.ItemIndex].Desc;
    ModelBotClassEdit.Text:=CacheModels[ModelListBox.ItemIndex].BotClass;
    ModelMeshEdit.Text:=CacheModels[ModelListBox.ItemIndex].SkinPackPrefix;
    ModelVoicetypeCombobox.ItemIndex:=CacheModels[ModelListBox.ItemIndex].IsMale;
    ModelFacesCheckbox.Checked:=CacheModels[ModelListBox.ItemIndex].HasFaces;
    ModelListBox.Tag:=0;
  end;{if}
end;

procedure TDatafileWizard.ModelStuffChange(Sender: TObject);
begin
  if (ModelListBox.Tag=0) AND (ModelListBox.ItemIndex>-1) then
  begin
    ModelListBox.Tag:=1;
    CacheModels[ModelListBox.ItemIndex].Desc:=ModelDescEdit.Text;
    CacheModels[ModelListBox.ItemIndex].BotClass:=ModelBotClassEdit.Text;
    CacheModels[ModelListBox.ItemIndex].SkinPackPrefix:=ModelMeshEdit.Text;
    CacheModels[ModelListBox.ItemIndex].IsMale:=ModelVoicetypeCombobox.ItemIndex;
    CacheModels[ModelListBox.ItemIndex].HasFaces:=ModelFacesCheckbox.Checked;
    ModelListBox.Items[ModelListBox.ItemIndex]:=ModelDescEdit.Text+' : '+ModelBotClassEdit.Text+' / '+ModelMeshEdit.Text;
    ModelListBox.Tag:=0;
  end;{if}
end;

procedure TDatafileWizard.AddModelBtnClick(Sender: TObject);
var x:TBotModel;
begin
  ModelDescEdit.Enabled:=TRUE;
  ModelBotClassEdit.Enabled:=TRUE;
  ModelMeshEdit.Enabled:=TRUE;
  ModelVoicetypeComboBox.Enabled:=TRUE;
  ModelFacesCheckbox.Enabled:=TRUE;
  x:=TBotModel.Create;
  x.BotClass:='MyPackage.MyClass';
  x.SkinPackPrefix:='MyMesh';
  x.IsMale:=1;
  x.HasFaces:=TRUE;
  x.Desc:='My Model';
  CacheModels.Append(x);
  ModelListBox.Items.Append('My Model');
  ModelListBox.ItemIndex:=ModelListBox.Items.Count-1;
  ModelListBoxClick(sender);
  ModelStuffChange(sender);
  NumModelsLabel.Caption:=IntToStr(ModelListBox.Items.Count)
end;

procedure TDatafileWizard.SkinListBoxClick(Sender: TObject);
begin
  if (SkinListBox.Tag=0) AND (SkinListBox.ItemIndex>-1) then
  begin
    SkinListBox.Tag:=1;
    SkinDescEdit.Text:=CacheSkins[SkinListBox.ItemIndex].Desc;
    SkinClassEdit.Text:=CacheSkins[SkinListBox.ItemIndex].UTName;
    FacesMemo.Lines.Text:=CacheSkins[SkinListBox.ItemIndex].Faces.Text;
    FaceDescsMemo.Lines.Text:=CacheSkins[SkinListBox.ItemIndex].FaceDescs.Text;
    TeamSkinsCheckbox.Checked:=CacheSkins[SkinListBox.ItemIndex].IsTeamSkinnable;
    SkinListBox.Tag:=0;
  end;{if}

end;

procedure TDatafileWizard.SkinStuffChange(Sender: TObject);
begin
if (SkinListBox.Tag=0) AND (SkinListBox.ItemIndex>-1) then
  begin

  SkinListBox.Tag:=1;
    CacheSkins[SkinListBox.ItemIndex].Desc:=SkinDescEdit.Text;
    CacheSkins[SkinListBox.ItemIndex].UTName:=SkinClassEdit.Text;
    CacheSkins[SkinListBox.ItemIndex].Faces.Text:=FacesMemo.Lines.Text;
    CacheSkins[SkinListBox.ItemIndex].FaceDescs.Text:=FaceDescsMemo.Lines.Text;
    CacheSkins[SkinListBox.ItemIndex].IsTeamSkinnable:=TeamSkinsCheckbox.Checked;
    SkinListBox.Items[SkinListBox.ItemIndex]:=SkinDescEdit.Text+' : '+SkinClassEdit.Text;
    SkinListBox.Tag:=0;
  end;{if}

end;

procedure TDatafileWizard.AddSkinBtnClick(Sender: TObject);
var x:TBotSkin;
begin
  SkinDescEdit.Enabled:=TRUE;
  SkinClassEdit.Enabled:=TRUE;
  FacesMemo.Enabled:=TRUE;
  FaceDescsMemo.Enabled:=TRUE;
  TeamSkinsCheckBox.Enabled:=TRUE;
  x:=TBotSkin.Create;
  x.UTName:='MyPackage.skn1';
  x.Faces.Text:='';
  x.FaceDescs.Text:='';
  x.Desc:='My Skin';
  x.IsTeamSkinnable:=TRUE;
  CacheSkins.Append(x);
  SkinListBox.Items.Append('My Skin');
  SkinListBox.ItemIndex:=SkinListBox.Items.Count-1;
  SkinListBoxClick(self);
  SkinStuffChange(Self);
  NumSkinsLabel.Caption:=IntToStr(SkinListBox.Items.Count)
end;

procedure TDatafileWizard.VoiceStuffChange(Sender: TObject);
begin
if (VoiceListBox.Tag=0) AND (VoiceListBox.ItemIndex>-1) then
  begin
  VoiceListBox.Tag:=1;
    CacheVoices[VoiceListBox.ItemIndex].Desc:=VoiceDescEdit.Text;
    CacheVoices[VoiceListBox.ItemIndex].VoiceClass:=VoiceClassEdit.Text;
    CacheVoices[VoiceListBox.ItemIndex].VoiceType:=VoiceTypeComboBox.ItemIndex;
    VoiceListBox.Items[VoiceListBox.ItemIndex]:=VoiceDescEdit.Text+' : '+VoiceClassEdit.Text;
    VoiceListBox.Tag:=0;
  end;{if}

end;

procedure TDatafileWizard.VoiceListBoxClick(Sender: TObject);
begin
if (VoiceListBox.Tag=0) AND (VoiceListBox.ItemIndex>-1) then
  begin
  VoiceListBox.Tag:=1;
  VoiceDescEdit.Enabled:=TRUE;
  VoiceClassEdit.Enabled:=TRUE;
  VoiceTypeCombobox.Enabled:=TRUE;
  VoiceDescEdit.Text:=CacheVoices[VoiceListBox.ItemIndex].Desc;
  VoiceClassEdit.Text:=CacheVoices[VoiceListBox.ItemIndex].VoiceClass;
  VoiceTypeComboBox.ItemIndex:=CacheVoices[VoiceListBox.ItemIndex].VoiceType;
  VoiceListBox.Tag:=0;
  end;{if}

end;

procedure TDatafileWizard.AddVoiceBtnClick(Sender: TObject);
var NV:TBotVoice;
begin
  NV:=TBotVoice.Create;
  NV.Desc:='My Voice';
  NV.VoiceClass:='MyVoicePackage.MyVoice';
  NV.VoiceType:=1;
  CacheVoices.Append(NV);
  VoiceListBox.Items.Append('My Voice');
  VoiceListBox.ItemIndex:=VoiceListbox.Items.Count-1;
  VoiceListBoxClick(sender);
  VoiceStuffChange(Sender);
  NumVoicesLabel.Caption:=IntToStr(VoiceListBox.Items.Count);
end;

procedure TDatafileWizard.ServerPackagesMemoChange(Sender: TObject);
begin
NumSPsLabel.Caption:=IntToStr(ServerPackagesMemo.Lines.Count);
end;

procedure TDatafileWizard.ModAuthorEditChange(Sender: TObject);
begin
ModSummaryLabel.Caption:=ModNameEdit.Text+' (by '+ModAuthorEdit.Text+')';
if NOT Editing then
  begin
    SaveModAsEdit.Text:=ModNameEdit.Text+' by '+ModAuthorEdit.Text;
    if ModNameEdit.Text=''
      then Self.Caption:=strUntitled+strCaptionSuffix
      else Self.Caption:=ModNameEdit.Text+strCaptionSuffix;
  end;
SaveModAsEditChange(Sender);
end;

procedure TDatafileWizard.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var s:string;
begin
if Editing then s:='Abort preset editing?' else s:='Abort preset creation?';
CanClose:= IHaveFinished OR (MessageDlg(s,mtConfirmation,[mbYes,mbNo],0)=mrYes);
end;

procedure TDatafileWizard.BitBtn7Click(Sender: TObject);
var
    ModPkgList:TStringList; i:integer;
Begin
ModPkgList:=TStringList.Create;
try
  OpenDialog1.Filter:='Old UTSC 1.0 presets (*.ut_pre)|*.ut_pre';
  OpenDialog1.DefaultExt:='ut_pre';
  if OpenDialog1.Execute then
  begin
    ModPkgList.LoadFromFile(OpenDialog1.Filename);
    if ModPkgList.Count>0 then ModNameEdit.Text:=ModPkgList[0];
    if ModPkgList.Count>1 then ModDescMemo.Lines.Text:=ModPkgList[1];
    if ModPkgList.Count>2 then WWWEdit.Text:=ModPkgList[2];
    if ModPkgList.Count>3 then
      for i:=3 to ModPkgList.Count-1 do
        ServerPackagesMemo.Lines.Append(ModPkgList[i]);
  end;
finally
ModPkgList.Free;
end;{try}
End;

procedure TDatafileWizard.DelMdlBtnClick(Sender: TObject);
begin
if (ModelListbox.ItemIndex>-1) then
  {delete the current model from the cache}
  CacheModels.Delete(ModelListbox.ItemIndex);
  {delete it from the listbox}
  ModelListBox.Items.Delete(ModelListbox.ItemIndex);
  {click on the first model, or failing that, grey everything out}
  if (ModelListBox.Items.Count>0) then
    begin
      ModelListbox.ItemIndex:=0;
      ModelListboxClick(Sender);
    end
  else
    begin
      ModelListbox.ItemIndex:=-1;
  ModelDescEdit.Enabled:=FALSE;
  ModelBotClassEdit.Enabled:=FALSE;
  ModelMeshEdit.Enabled:=FALSE;
  FaceDescsMemo.Enabled:=FALSE;
  ModelVoicetypeCombobox.Enabled:=FALSE;
  ModelFacesCheckBox.Enabled:=FALSE;
    end;
  NumModelsLabel.Caption:=IntToStr(ModelListBox.Items.Count);
end;


procedure TDatafileWizard.DelSkinBtnClick(Sender: TObject);
begin
if (SkinListbox.ItemIndex>-1) then
  {delete the current model from the cache}
  CacheSkins.Delete(SkinListbox.ItemIndex);
  {delete it from the listbox}
  SkinListBox.Items.Delete(SkinListbox.ItemIndex);
  {click on the first model, or failing that, grey everything out}
  if (SkinListBox.Items.Count>0) then
    begin
      SkinListbox.ItemIndex:=0;
      SkinListboxClick(Sender);
    end{if}
  else
    begin
      SkinListbox.ItemIndex:=-1;
  SkinDescEdit.Enabled:=FALSE;
  SkinClassEdit.Enabled:=FALSE;
  FacesMemo.Enabled:=FALSE;
  FaceDescsMemo.Enabled:=FALSE;
  TeamSkinsCheckBox.Enabled:=FALSE;
    end;{else}
NumSkinsLabel.Caption:=IntToStr(SkinListBox.Items.Count);
End;

Procedure TDatafileWizard.FormCreate(Sender: TObject);
Begin
Editing:=FALSE;
CacheModels:= TBotModelList.Create;
CacheSkins:= TBotSkinList.Create;
CacheVoices:= TBotVoiceList.Create;
End;

Procedure TDatafileWizard.FormDestroy(Sender: TObject);
Begin
CacheModels.Free;
CacheSkins.Free;
CacheVoices.Free;
End;

procedure TDatafileWizard.DelVoxBtnClick(Sender: TObject);
begin
if (VoiceListbox.ItemIndex>-1) then
  {delete the current one from the cache}
  CacheVoices.Delete(VoiceListbox.ItemIndex);
  {delete it from the listbox}
  VoiceListBox.Items.Delete(VoiceListbox.ItemIndex);
  {click on the first model, or failing that, grey everything out}
  if (VoiceListBox.Items.Count>0) then
    begin
      VoiceListbox.ItemIndex:=0;
      VoiceListboxClick(Sender);
    end{if}
  else
    begin
      VoiceListbox.ItemIndex:=-1;
  VoiceDescEdit.Enabled:=FALSE;
  VoiceClassEdit.Enabled:=FALSE;
  VoiceTypeCombobox.Enabled:=FALSE;
    end;{else}
NumVoicesLabel.Caption:=IntToStr(VoiceListBox.Items.Count);
end;

procedure TDatafileWizard.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
Action:=caFree;
end;

procedure TDatafileWizard.BitBtn6Click(Sender: TObject);
var Ini:TIniFile;
Begin
OpenDialog1.Filter:='UTSC 2.x data (*.utsc.txt)|*.utsc.txt|All files|*.*';
OpenDialog1.DefaultExt:='ut_pre';
if OpenDialog1.Execute then begin
  Ini:=TIniFile.Create(OpenDialog1.Filename);
  try
    ModAuthorEdit.Text:=Ini.ReadString(hMod,vAuthor,'unknown');
    EmailEdit.Text:=Ini.ReadString(hMod,vEmail,'');
    WWWEdit.Text:=Ini.ReadString(hMod,vWWW,'');
    AltContactEdit.Text:=Ini.ReadString(hMod,vOtherContact,'');
  finally
    Ini.Free;
  end;{try}
end;{if}
End;

procedure TDatafileWizard.AddSkinIntBtnClick(Sender: TObject);
var X:TBotSkinList; i:integer;
begin
 X:=SkinIntLoaderForm.LoadSkins;
 try
 if X.Count>0 then
   for i:=0 to X.count-1 do begin
     CacheSkins.Append(X[i].Clone);
     SkinDescEdit.Enabled:=TRUE;
     SkinClassEdit.Enabled:=TRUE;
     FacesMemo.Enabled:=TRUE;
     FaceDescsMemo.Enabled:=TRUE;
     TeamSkinsCheckBox.Enabled:=TRUE;
     SkinListBox.Items.Append('My Skin');
     SkinListBox.ItemIndex:=SkinListBox.Items.Count-1;
     SkinListBoxClick(self);
     SkinStuffChange(Self);
     NumSkinsLabel.Caption:=IntToStr(SkinListBox.Items.Count)
 end;{for}
 finally
 X.Free;end;{try}
end;

procedure TDatafileWizard.AddIntMdlBtnClick(Sender: TObject);
var Cache:TBotModelList; i:integer;
begin
  Cache:=ModelIntLoaderForm.LoadModels;
  try
  if Cache.Count>0 then
    for i:=0 to Cache.Count-1 do
    begin
      ModelDescEdit.Enabled:=TRUE;
      ModelBotClassEdit.Enabled:=TRUE;
      ModelMeshEdit.Enabled:=TRUE;
      ModelVoicetypeComboBox.Enabled:=TRUE;
      ModelFacesCheckbox.Enabled:=TRUE;
      CacheModels.Append(Cache[i].Clone);
      ModelListBox.Items.Append('My Model');
      ModelListBox.ItemIndex:=ModelListBox.Items.Count-1;
      ModelListBoxClick(sender);
      ModelStuffChange(sender);
    end;{for}
  finally
  Cache.Free;
  end;{try}
  NumModelsLabel.Caption:=IntToStr(ModelListBox.Items.Count);
end;

procedure TDatafileWizard.Contents1Click(Sender: TObject);
begin
AboutBox.GetHelp(helpContents);
end;

procedure TDatafileWizard.AboutUTSC1Click(Sender: TObject);
begin
AboutBox.GetHelp(helpAbout);
end;

procedure TDatafileWizard.Contextsensitivehelp1Click(Sender: TObject);
begin
Aboutbox.GetHelp(helpMakeData);
end;

procedure TDatafileWizard.ModDescMemoChange(Sender: TObject);
var i:integer; s:string;
const ReturnChars = [#0{null},#7{tab},#13{CR},#10{LF}];
Begin
  if ModDescMemo.Tag=0 then begin
    ModDescMemo.Tag:=1;
    s:=ModDescMemo.Text;
    for i:=1 to length(s) do
      if s[i] in ReturnChars then s[i]:=' ';
  end;{if}
End;

procedure TDatafileWizard.AddVoiceINTBtnClick(Sender: TObject);
var Cache:TBotVoiceList; i:integer;
Begin
  Cache:=VoiceIntLoaderForm.LoadVoices;
  try
  if Cache.Count>0 then
    for i:=0 to Cache.Count-1 do
    begin
      VoiceDescEdit.Enabled:=TRUE;
      VoiceClassEdit.Enabled:=TRUE;
      VoicetypeComboBox.Enabled:=TRUE;
      CacheVoices.Append(Cache[i].Clone);
      VoiceListBox.Items.Append('');
      VoiceListBox.ItemIndex:=VoiceListBox.Items.Count-1;
      VoiceListBoxClick(sender);
      VoiceStuffChange(sender);
    end;{for}
  finally
  Cache.Free;
  end;{try}
  NumVoicesLabel.Caption:=IntToStr(VoiceListBox.Items.Count);
End;

END.
