{
This file is part of Unreal Tournament System Config version 210f.

Copyright (C) 2000, 2003 Simon McVittie.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit MdiChildBotLib;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Menus,Knowledge, TBotDefine, TBigKegOBotsDefine;

type
  TChildBotLibForm = class(TForm)
    BotsListBox: TListBox;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    BotNameComboBox: TComboBox;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    BotFaceComboBox: TComboBox;
    BotSkinComboBox: TComboBox;
    BotModelComboBox: TComboBox;
    BotTeamComboBox: TComboBox;
    Label6: TLabel;
    GroupBox3: TGroupBox;
    JumpyCheckBox: TCheckBox;
    SkillScrollBar: TScrollBar;
    Label7: TLabel;
    Label8: TLabel;
    AccuracyScrollBar: TScrollBar;
    AlertnessScrollBar: TScrollBar;
    StrafingScrollBar: TScrollBar;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    CombatStyleScrollbar: TScrollBar;
    AddBotBtn: TBitBtn;
    DelBotBtn: TBitBtn;
    Label13: TLabel;
    CurrLibNameLabel: TLabel;
    Label14: TLabel;
    BotVoiceComboBox: TComboBox;
    CampingScrollBar: TScrollBar;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    FaveWeaponComboBox: TComboBox;
    SortBtn: TBitBtn;
    Label19: TLabel;
    MainMenu1: TMainMenu;
    Bots1: TMenuItem;
    Sortbyname1: TMenuItem;
    Insertnewbot1: TMenuItem;
    Deleteselectedbot1: TMenuItem;
    CustomModelEdit: TEdit;
    CustomSkinEdit: TEdit;
    CustomFaceEdit: TEdit;
    CustomVoiceEdit: TEdit;
    NoTCsLabel: TLabel;
    NoFaceChangeLabel: TLabel;
    WritetoUTINI1: TMenuItem;
    ImportUTINI1: TMenuItem;
    Importappendedoption: TMenuItem;
    importasnewlistoption: TMenuItem;
    N2: TMenuItem;
    Help1: TMenuItem;
    AboutUTSC1: TMenuItem;
    Contents1: TMenuItem;
    N3: TMenuItem;
    Contextsensitivehelp1: TMenuItem;
    procedure BotsListBoxClick(Sender: TObject);
    procedure BotNameComboBoxChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure AddBotBtnClick(Sender: TObject);
    procedure ExportINIBtnClick(Sender: TObject);
    procedure NewBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure SaveAsBtnClick(Sender: TObject);
    procedure OpenBtnClick(Sender: TObject);
    procedure DelBotBtnClick(Sender: TObject);
    procedure ImportINIBtnClick(Sender: TObject);
    procedure BotAttributeChange(Sender:TObject);
    procedure BotModelComboBoxChange(Sender: TObject);
    procedure FaveWeaponComboBoxChange(Sender: TObject);
    procedure BotSkinComboBoxChange(Sender: TObject);
    procedure BotFaceComboBoxChange(Sender: TObject);
    procedure BotVoiceComboBoxChange(Sender: TObject);
    procedure RefreshBotsListBox;
    procedure SortBtnClick(Sender: TObject);
    procedure OpenAndAppendBtnClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ChangeCustom(Sender: TObject);
    procedure ChangeEnabling(Box:TEdit;SwitchOn:boolean);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OpenFile(filename:string);
    procedure SaveFile(filename:string);
    procedure SaveOption;
    procedure Contextsensitivehelp1Click(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure AboutUTSC1Click(Sender: TObject);
    procedure ReloadKnowledge(Sender: TObject);
    procedure Closelibrary1Click(Sender: TObject);
    procedure importasnewlistoptionClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
      BotList: TBigKegOBots;
  end;

 const NumFaveWeaps=12;
     FaveWeaponsList:array[0..NumFaveWeaps] of string = ('','Botpack.ImpactHammer',
                                         'Botpack.Chainsaw',
                                         'Botpack.Enforcer',
                                         'Botpack.DoubleEnforcer',
                                         'Botpack.UT_Biorifle',
                                         'Botpack.ShockRifle',
                                         'Botpack.PulseGun',
                                         'Botpack.Ripper',
                                         'BotPack.Minigun2',
                                         'Botpack.UT_FlakCannon',
                                         'BotPack.UT_Eightball',
                                         'Botpack.SniperRifle');
  strNoFileLoaded='<untitled>';

var
  ChildBotLibForm: TChildBotLibForm;

implementation
uses UTSharedUtils1, BotFiles, MainMenu,
  BotSaveWizard, UTServerConfigGlobal,About,ModelsLoader;

{$R *.DFM}

procedure TChildBotLibForm.BotsListBoxClick(Sender: TObject);
var B:TBot;i:integer;
begin
  if (BotsListBox.ItemIndex<>-1) then
    begin
      Self.Tag:=1;
      B:=BotList.Data[BotsListBox.ItemIndex];
      BotNameComboBox.Enabled:=TRUE;
      BotModelComboBox.Enabled:=TRUE;
      BotSkinComboBox.Enabled:=TRUE;
      BotFaceComboBox.Enabled:=TRUE;
      BotVoiceComboBox.Enabled:=TRUE;
      BotTeamComboBox.Enabled:=TRUE;
      JumpyCheckbox.Enabled:=TRUE;
      FaveWeaponComboBox.Enabled:=TRUE;
      SkillScrollBar.Enabled:=TRUE;
      AccuracyScrollBar.Enabled:=TRUE;
      CombatStyleScrollBar.Enabled:=TRUE;
      AlertnessScrollBar.Enabled:=TRUE;
      StrafingScrollBar.Enabled:=TRUE;
      CampingScrollBar.Enabled:=TRUE;

      BotNameComboBox.Text:=B.Name;
            
      BotModelComboBox.ItemIndex:=BotModelComboBox.Items.Count-1;
      CustomModelEdit.Text:=B.ModelClass;
      ChangeEnabling(CustomModelEdit,TRUE);
      BotFaceCombobox.Visible:=TRUE;
      NoFaceChangeLabel.Visible:=FALSE;
      CustomFaceEdit.Visible:=TRUE;
      if MasterModelsList.Count>0 then
        for i:=0 to MasterModelsList.Count-1 do
          begin
            if TextEqu(MasterModelsList[i].BotClass,B.Modelclass) then begin
              ChangeEnabling(CustomModelEdit,FALSE);
              BotModelCombobox.ItemIndex:=i;
                if MasterModelsList[BotModelComboBox.ItemIndex].HasFaces then
                begin
                 BotFaceCombobox.Visible:=TRUE;
                 NoFaceChangeLabel.Visible:=FALSE;
                 CustomFaceEdit.Visible:=TRUE;
                end else begin
                 BotFaceCombobox.Visible:=FALSE;
                 NoFaceChangeLabel.Visible:=TRUE;
                 CustomFaceEdit.Visible:=FALSE;
                end;
            end;
            end;
      FillSkinListBoxFromMasterList(BotModelCombobox.ItemIndex,BotModelComboBox.Items.Count-1,BotSkinCombobox.Items);
      BotSkinComboBox.ItemIndex:=BotSkinComboBox.Items.Count-1;
      CustomSkinEdit.Text:=B.Skin;
      ChangeEnabling(CustomSkinEdit,TRUE);
      NoTCsLabel.Visible:=FALSE;
      if (BotModelCombobox.ItemIndex<BotModelComboBox.Items.Count-1) and
         (MasterModelsList[BotModelCombobox.ItemIndex].Skins.Count>0) then
        for i:=0 to MasterModelsList[BotModelCombobox.ItemIndex].Skins.Count-1 do
          begin
            if TextEqu(MasterModelsList[BotModelCombobox.ItemIndex].Skins[i].UTName,B.Skin) then
              begin
              BotSkinCombobox.ItemIndex:=i;
              ChangeEnabling(CustomSkinEdit,FALSE);
              if MasterModelsList[BotModelComboBox.ItemIndex].Skins[BotSkinComboBox.ItemIndex].IsTeamSkinnable then
                begin
                  
                end else begin
                  NoTCsLabel.Visible:=TRUE;
                end;
              end;
            end;

      CustomFaceEdit.Text:=B.Face;
      FillFaceListBoxFromMasterList(BotModelCombobox.ItemIndex,BotSkinCombobox.ItemIndex,BotSkinComboBox.Items.Count-1,BotFaceCombobox.Items);
      ChangeEnabling(CustomFaceEdit,TRUE);
      BotFaceComboBox.ItemIndex:=BotFaceComboBox.Items.Count-1;
      if (BotSkinCombobox.ItemIndex<BotSkinComboBox.Items.Count-1) and
         (MasterModelsList[BotModelCombobox.ItemIndex].Skins[BotSkinCombobox.ItemIndex].Faces.Count>0) then
        for i:=0 to MasterModelsList[BotModelCombobox.ItemIndex].Skins[BotSkinCombobox.ItemIndex].Faces.Count-1 do
          begin
            if TextEqu(MasterModelsList[BotModelCombobox.ItemIndex].Skins[BotSkinCombobox.ItemIndex].Faces[i],B.Face) then
              begin
              ChangeEnabling(CustomFaceEdit,FALSE);
              BotFaceCombobox.ItemIndex:=i;
              end;
          end;

      CustomVoiceEdit.Text:=B.Voice;
      if (BotModelComboBox.ItemIndex<BotModelComboBox.Items.Count-1) then
        FillVoiceListBoxFromMasterList(
                  MasterModelsList[BotModelCombobox.ItemIndex].IsMale,
                  BotVoiceCombobox.Items)
      else
        FillVoiceListBoxFromMasterList(255,BotVoiceCombobox.Items);

      ChangeEnabling(CustomVoiceEdit,TRUE);
      BotVoiceComboBox.ItemIndex:=BotVoiceComboBox.Items.Count-1;
      if (CurrentMasterVoiceList.Count>0) then
        for i:=0 to CurrentMasterVoiceList.Count-1 do
          begin
            if TextEqu(CurrentMasterVoiceList[i].VoiceClass,B.Voice) then
              begin
              ChangeEnabling(CustomVoiceEdit,FALSE);
              BotVoiceCombobox.ItemIndex:=i;
              end;
          end;
      CustomVoiceEdit.Text:=B.Voice;
      FaveWeaponCombobox.ItemIndex:=0;
      for i:=0 to NumFaveWeaps do
          begin
            if TextEqu(FaveWeaponsList[i],B.FavoriteWeapon) then
              begin
              FaveWeaponCombobox.ItemIndex:=i;
              end;
          end;
      if (B.Team=255)
       then BotTeamComboBox.ItemIndex:=4
       else BotTeamComboBox.ItemIndex:=B.Team;
      JumpyCheckbox.Checked:=B.Jumpy;

      SkillScrollBar.Position:=round(B.Skill*20);
      AccuracyScrollBar.Position:=round(B.Accuracy*20);
      CombatStyleScrollBar.Position:=round(B.CombatStyle*2);
      AlertnessScrollBar.Position:=round(B.Alertness*20);
      StrafingScrollBar.Position:=round(B.StrafingAbility*20);
      CampingScrollBar.Position:=round(B.Camping*20);

      {BotModelComboBoxChange(sender);} Self.Tag:=0;
    end
  else
    begin
      BotNameComboBox.Enabled:=FALSE;
      BotModelComboBox.Enabled:=FALSE;
      BotSkinComboBox.Enabled:=FALSE;
      BotFaceComboBox.Enabled:=FALSE;
      BotVoiceComboBox.Enabled:=FALSE;
      BotTeamComboBox.Enabled:=FALSE;
      JumpyCheckbox.Enabled:=FALSE;
      SkillScrollBar.Enabled:=FALSE;
      AccuracyScrollBar.Enabled:=FALSE;
      CombatStyleScrollBar.Enabled:=FALSE;
      AlertnessScrollBar.Enabled:=FALSE;
      StrafingScrollBar.Enabled:=FALSE;
      CampingScrollBar.Enabled:=FALSE;
      FaveWeaponComboBox.Text:='';
      FaveWeaponComboBox.Enabled:=FALSE;
      BotNameComboBox.Text:='';
      CustomModelEdit.Text:='';
      CustomSkinEdit.Text:='';
      CustomFaceEdit.Text:='';
      CustomVoiceEdit.Text:='';
      BotTeamComboBox.ItemIndex:=4;
      JumpyCheckbox.Checked:=FALSE;
      SkillScrollBar.Position:=0;
      AccuracyScrollBar.Position:=0;
      CombatStyleScrollBar.Position:=0;
      AlertnessScrollBar.Position:=0;
      StrafingScrollBar.Position:=0;
      CampingScrollBar.Position:=0;
      Self.Tag:=0;
    end;
end;

procedure TChildBotLibForm.BotNameComboBoxChange(Sender: TObject);
var i:integer;
begin
  if not (Self.Tag=1) then
  begin
    Self.Tag:=1;
    i:=BotNameComboBox.SelStart;
    BotNameComboBox.Text:=SpacesToUnderscores(BotNameComboBox.Text);
    BotNameComboBox.SelStart:=i;
    Self.Tag:=0;
    BotAttributeChange(Self);
  end;
end;

procedure TChildBotLibForm.FormCreate(Sender: TObject);
begin
  BotList:=TBigKegOBots.Create;
  BotList.Init;

  NewBtnClick(Self);
end;



procedure TChildBotLibForm.FormDestroy(Sender: TObject);
begin
  BotList.Free;
end;

procedure TChildBotLibForm.AddBotBtnClick(Sender: TObject);
begin
  BotList.Append(BlankBot);
  BotsListBox.Items.Append(BotDescString(BlankBot));
  BotsListBox.ItemIndex:=BotsListBox.Items.Count-1;
  BotsListBoxClick(Self);
end;

procedure TChildBotLibForm.ExportINIBtnClick(Sender: TObject);
var i:integer;
begin
  {@@@ FIXME: safe for MDI but a little too specific. Consider giving BSW a
  method ExportBots(B:TBigKegOBots) in future.}
  
  {clear arrays}
  BotSaveWizardForm.BotsChecklist.Clear;
  BotSaveWizard.TheExportBotList.Clear;
  BotSaveWizardForm.txtFieldComboBox.ItemIndex:=0;
  BotSaveWizardForm.txtActionComboBox.ItemIndex:=1;
  BotSaveWizardForm.txtComparisonComboBox.ItemIndex:=0;
  BotSaveWizardForm.txtTextEdit.Text:='';
  BotSaveWizardForm.nmActionCombobox.ItemIndex:=1;
  BotSaveWizardForm.nmComparisonComboBox.ItemIndex:=0;
  BotSaveWizardForm.nmFieldCombobox.ItemIndex:=0;
  BotSaveWizardForm.nmFieldComboboxChange(sender);
  BotSaveWizardForm.nmThresholdScrollBar.Position:=0;
  BotSaveWizardForm.nmThresholdDummyEdit.Text:='0.000000';
  BotSaveWizardForm.tmActionCombobox.ItemIndex:=1;
  BotSaveWizardForm.tmTeamComboBox.ItemIndex:=0;
  BotSaveWizardForm.jbActionCombobox.ItemIndex:=1;
  BotSaveWizardForm.jbConditionComboBox.ItemIndex:=1;
  BotSaveWizardForm.PageControl1.ActivePage:=BotSaveWizardForm.spPage;
  {copy across bots}
  if (Botlist.Count>0) then
  for i:=0 to BotList.Count-1 do
    begin
      BotSaveWizardForm.BotsChecklist.Items.Append(BotDescString(BotList[i]));
      BotSaveWizard.TheExportBotList.Append(BotList[i]);
      BotSaveWizardForm.BotsChecklist.Checked[i]:=TRUE;
    end;{for}
  BotSaveWizardForm.ShowModal;
end;

procedure TChildBotLibForm.NewBtnClick(Sender: TObject);
begin
  BotsListBox.Items.Clear;
  BotList.Clear;
  CurrLibNameLabel.Caption:=strNoFileLoaded;
  BotsListBoxClick(Self);
end;

procedure TChildBotLibForm.SaveFile(Filename:string);
begin
  SaveV2BotList(BotList,Filename);
  CurrLibNameLabel.Caption:=Filename;
end;

procedure TChildBotLibForm.SaveOption;
begin
if (CurrLibNameLabel.Caption=strNoFileLoaded) or (CurrLibNameLabel.Caption='')
  then begin
    MainMenuForm.LibrarySaveDialog.InitialDir:=global_botfolder;
    if MainMenuForm.LibrarySaveDialog.Execute
      then SaveFile(MainMenuForm.LibrarySaveDialog.Filename);
  end
else SaveFile(CurrLibNameLabel.Caption);
end;

procedure TChildBotLibForm.SaveBtnClick(Sender: TObject);
begin
if (CurrLibNameLabel.Caption=strNoFileLoaded) or (CurrLibNameLabel.Caption='')
  then SaveAsBtnClick(Sender)
else SaveV2BotList(BotList,CurrLibNameLabel.Caption);
end;

procedure TChildBotLibForm.SaveAsBtnClick(Sender: TObject);
begin
MainMenuForm.LibrarySaveDialog.InitialDir:=global_botfolder;
if MainMenuForm.LibrarySaveDialog.Execute
then begin
  SaveV2BotList(BotList,MainMenuForm.LibrarySaveDialog.Filename);
  CurrLibNameLabel.Caption:=MainMenuForm.LibrarySaveDialog.Filename;
  end;
end;

procedure TChildBotLibForm.OpenBtnClick(Sender: TObject);
Begin
MainMenuForm.LibraryOpenDialog.InitialDir:=global_botfolder;
if MainMenuForm.LibraryOpenDialog.Execute
then begin
  BotList.Clear;
  BotsListBox.Items.Clear;
  OpenFile(MainMenuForm.LibraryOpenDialog.FileName);
  end;
End;

procedure TChildBotlibForm.OpenFile(Filename:string);
Begin
if (Filename<>'') AND FileExists(Filename) then begin
  if TextEqu(ExtractFileExt(Filename),'.ut_botlib')
    then LoadBotList(BotList,Filename)
    else LoadV2BotList(BotList,Filename);
  CurrLibNameLabel.Caption:=Filename;
  Self.Caption:=ExtractFileName(Filename)+' - Bot Library Manager';
  RefreshBotsListbox;
end;{if}
End;

procedure TChildBotLibForm.DelBotBtnClick(Sender: TObject);
var i:integer;
begin
i:=BotsListBox.ItemIndex;
  if (i>-1) then
    begin
      BotList.Delete(i);
      BotsListBox.Items.Delete(i);
      if (BotsListBox.Items.Count-1>=i)
        then BotsListBox.ItemIndex:=i
        else BotsListBox.ItemIndex:=i-1;
      BotsListBoxClick(Sender);
    end;
end;

procedure TChildBotLibForm.ImportINIBtnClick(Sender: TObject);
var f:string;
begin
f:=Global.UTUserIni;
  if FileExists(f)
      then begin
      ImportBotList(BotList,f);
      RefreshBotsListBox;
      end;{if}
end;

procedure TChildBotLibForm.BotAttributeChange(Sender:TObject);
var B:TBot;
Begin
  if (Self.Tag<>1)
    and (BotsListbox.Items.Count>0) and (BotsListBox.ItemIndex>-1) then begin
  Self.Tag:=1;

    B.Name:=BotNameComboBox.Text;
    B.ModelClass:=CustomModelEdit.Text;
    B.Skin:=CustomSkinEdit.Text;
    B.Face:=CustomFaceEdit.Text;
    B.Voice:=CustomVoiceEdit.Text;
    B.FavoriteWeapon:=FaveWeaponsList[FaveWeaponComboBox.ItemIndex];
    if BotTeamComboBox.ItemIndex in [0..3]
      then B.Team:=BotTeamComboBox.ItemIndex
      else B.Team:=255;
    B.Skill:=SkillScrollBar.Position/20;
    B.Accuracy:=AccuracyScrollBar.Position/20;
    B.StrafingAbility:=StrafingScrollBar.Position/20;
    B.Alertness:=AlertnessScrollBar.Position/20;
    B.Camping:=CampingScrollBar.Position/20;
    B.CombatStyle:=CombatStyleScrollBar.Position/2;
    B.Jumpy:=JumpyCheckBox.Checked;
  BotsListBox.Items[BotsListBox.ItemIndex]:=BotDescString(B);
  BotList.Data[BotsListBox.ItemIndex]:=B;
  Self.Tag:=0;
  end;{if}
End;

procedure TChildBotLibForm.BotModelComboBoxChange(Sender: TObject);
begin
if (Self.Tag<>1) then
    begin
{leftovers from the old system}
    {if (Length(BotModelComboBox.Text)>1)
       and (BotModelComboBox.Text[1]='/')
       and (BotModelComboBox.Text[2]='/')
       then begin BotModelComboBox.text:='';BotModelComboBox.ItemIndex:=-1; end;}
  if (BotModelComboBox.ItemIndex = BotModelComboBox.Items.Count-1) then
  {Custom...}
  begin
  ChangeEnabling(CustomModelEdit,TRUE);
  BotFaceCombobox.Visible:=TRUE;
  NoFaceChangeLabel.Visible:=FALSE;
  CustomFaceEdit.Visible:=TRUE;
  FillVoiceListBoxFromMasterList(255,BotVoiceComboBox.Items);
  BotVoiceComboBox.ItemIndex:=0;
  BotVoiceComboBoxChange(Sender);
  end
  else
  begin
  CustomModelEdit.Text:=MasterModelsList[BotModelComboBox.ItemIndex].BotClass;
  ChangeEnabling(CustomModelEdit,FALSE);
  FillVoiceListBoxFromMasterList(MasterModelsList[BotModelComboBox.ItemIndex].IsMale
                                 ,BotVoiceComboBox.Items);
  BotVoiceComboBox.ItemIndex:=0;
  BotVoiceComboBoxChange(Sender);
    if MasterModelsList[BotModelComboBox.ItemIndex].HasFaces then
      begin
        BotFaceCombobox.Visible:=TRUE;
        NoFaceChangeLabel.Visible:=FALSE;
        CustomFaceEdit.Visible:=TRUE;
      end else begin
        BotFaceCombobox.Visible:=FALSE;
        NoFaceChangeLabel.Visible:=TRUE;
        CustomFaceEdit.Visible:=FALSE;
      end;
  end;
  FillSkinListboxFromMasterList(BotModelCombobox.ItemIndex,
                                BotModelCombobox.Items.Count-1,
                                BotSkinComboBox.Items);
  BotSkinComboBox.ItemIndex:=0;
  BotSkinComboBoxChange(Sender);
  {BotAttributeChange(Self); -now skin's responsibility}
end;{if}
End;

procedure TChildBotLibForm.FaveWeaponComboBoxChange(Sender: TObject);
begin
if (Self.Tag<>1) then
    begin
    BotAttributeChange(Self);
end;{if tag<>1}
End;

procedure TChildBotLibForm.BotSkinComboBoxChange(Sender: TObject);
Begin
if (Self.Tag<>1) then
    begin
{    if (Length(BotSkinComboBox.Text)>1)
       and (BotSkinComboBox.Text[1]='/')
       and (BotSkinComboBox.Text[2]='/')
       then begin BotSkinComboBox.text:=''; BotSkinComboBox.ItemIndex:=-1; end;}
  if (BotSkinComboBox.ItemIndex = BotSkinComboBox.Items.Count-1) then
  {Custom...}
  begin
 { CustomSkinEdit.Text:='';      }
    ChangeEnabling(CustomSkinEdit,TRUE);
    NoTCsLabel.Visible:=FALSE;
  end
  else
  begin
    CustomSkinEdit.Text:=
      MasterModelsList[BotModelComboBox.ItemIndex].Skins[BotSkinComboBox.ItemIndex].UTName;
    ChangeEnabling(CustomSkinEdit,FALSE);
      if MasterModelsList[BotModelComboBox.ItemIndex].Skins[BotSkinComboBox.ItemIndex].IsTeamSkinnable then
      begin
        NoTCsLabel.Visible:=FALSE;
      end else begin
        NoTCsLabel.Visible:=TRUE;
      end;
  end;
  FillFaceListboxFromMasterList(BotModelCombobox.ItemIndex,
                                BotSkinCombobox.ItemIndex,
                                BotSkinCombobox.Items.Count-1,
                                BotFaceComboBox.Items);
  BotFaceComboBox.ItemIndex:=0;
  BotFaceComboBoxChange(Sender);
    {BotAttributeChange(Self); -now face's problem}
end;{if tag<>1}
End;

procedure TChildBotLibForm.BotFaceComboBoxChange(Sender: TObject);
begin
if (Self.Tag<>1) then
    begin
{    if (Length(BotFaceComboBox.Text)>1)
       and (BotFaceComboBox.Text[1]='/')
       and (BotFaceComboBox.Text[2]='/')
       then begin BotFaceComboBox.text:=''; BotFaceComboBox.ItemIndex:=-1; end;}
if CustomFaceEdit.Visible then begin
  if (BotFaceComboBox.ItemIndex = BotFaceComboBox.Items.Count-1) then
  {Custom...}
  begin
    {CustomFaceEdit.Text:=''; }
    CustomFaceEdit.ReadOnly:=FALSE;
    CustomFaceEdit.Color:=clWindow;
  end
  else
  begin
    CustomFaceEdit.Text:=
      MasterModelsList[BotModelComboBox.ItemIndex]
       .Skins[BotSkinComboBox.ItemIndex]
       .Faces[BotFaceComboBox.ItemIndex];
    CustomFaceEdit.ReadOnly:=TRUE;
    CustomFaceEdit.Color:=clBtnFace;
  end;{if}
end else begin
  BotFaceComboBox.ItemIndex:=BotFaceComboBox.Items.Count-1;
  CustomFaceEdit.Text:='';
end;
{finally!} BotAttributeChange(Self);
end;{if tag<>1}
End;

procedure TChildBotLibForm.BotVoiceComboBoxChange(Sender: TObject);
begin
if (Self.Tag<>1) then
    begin
{    if (Length(BotVoiceComboBox.Text)>1)
       and (BotVoiceComboBox.Text[1]='/')
       and (BotVoiceComboBox.Text[2]='/')
       then begin BotVoiceComboBox.text:='';BotVoiceComboBox.ItemIndex:=-1; end; }

  if (BotVoiceComboBox.ItemIndex = BotVoiceComboBox.Items.Count-1) then
  {Custom...}
  begin
 { CustomSkinEdit.Text:='';      }
    
    NoTCsLabel.Visible:=FALSE;
  end
  else
  begin
    CustomVoiceEdit.Text:=
      CurrentMasterVoiceList[BotVoiceComboBox.ItemIndex].VoiceClass;
    CustomVoiceEdit.ReadOnly:=TRUE;
    CustomVoiceEdit.Color:=clBtnFace;
  end;

    BotAttributeChange(Self);
end;{if tag<>1}
End;

procedure TChildBotLibForm.RefreshBotsListBox;
var i:integer;
Begin
BotsListBox.Clear;
if (BotList.Count>0) then begin
  for i:=0 to (BotList.Count-1) do
  BotsListBox.Items.Append(BotDescString(BotList.Data[i]));
  BotsListBox.ItemIndex:=0;
end;
BotsListBoxClick(self);
End;

procedure TChildBotLibForm.SortBtnClick(Sender: TObject);
begin
  BotList.Sort;
  RefreshBotsListBox;
end;

procedure TChildBotLibForm.OpenAndAppendBtnClick(Sender: TObject);
var B:TBot;
    i:integer;
Begin
MainMenuForm.LibraryOpenDialog.InitialDir:=global_botfolder;
if MainMenuForm.LibraryOpenDialog.Execute
then begin
  BotsListBox.Items.Clear;
  if TextEqu(ExtractFileExt(MainMenuForm.LibraryOpenDialog.FileName),'.ut_botlib')
    then LoadBotList(BotList,MainMenuForm.LibraryOpenDialog.Filename)
    else LoadV2BotList(BotList,MainMenuForm.LibraryOpenDialog.Filename);
  if (BotList.Count>0) then
  for i:=0 to BotList.Count-1 do
    begin
      B:=BotList[i];
      BotsListBox.Items.Append(BotDescString(B));
    end;{for}
  end;{if}
End;

procedure TChildBotLibForm.About1Click(Sender: TObject);
begin
AboutBox.ShowModal;
end;

procedure TChildBotLibForm.FormShow(Sender: TObject);
begin
  FillModelListBoxFromMasterList(BotModelComboBox.Items);
  {load details of first bot, if there is one}
  Self.BotsListBoxClick(Sender);
  {
  FillModelListboxFromMasterList(BotModelComboBox.Items);
  BotModelComboBox.ItemIndex:=0;
  FillSkinListBoxFromMasterList(BotModelComboBox.ItemIndex,BotModelComboBox.Items.Count,BotSkinComboBox.Items);
  BotSkinComboBox.ItemIndex:=0;
  FillFaceListBoxFromMasterList(BotModelComboBox.ItemIndex,BotSkinComboBox.ItemIndex,BotSkinComboBox.Items.Count,BotFaceComboBox.Items);
  BotFaceComboBox.ItemIndex:=0;
  }
end;

procedure TChildBotLibForm.ChangeCustom(Sender: TObject);
begin
  BotAttributeChange(sender);
end;

procedure TChildBotLibForm.ChangeEnabling(Box:TEdit;SwitchOn:boolean);
Begin
  box.ReadOnly:=not SwitchOn;
  if SwitchOn then Box.Color:=clWindow else Box.Color:=clBtnFace;
End;

procedure TChildBotLibForm.BitBtn1Click(Sender: TObject);
begin
Self.Close;
end;

procedure TChildBotLibForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Action:=caFree;
end;

procedure TChildBotLibForm.Contextsensitivehelp1Click(Sender: TObject);
begin
AboutBox.GetHelp(helpBotlib);
end;

procedure TChildBotLibForm.Contents1Click(Sender: TObject);
begin
AboutBox.GetHelp(helpContents);
end;

procedure TChildBotLibForm.AboutUTSC1Click(Sender: TObject);
begin
AboutBox.GetHelp(helpAbout);
end;

procedure TChildBotLibForm.ReloadKnowledge(Sender: TObject);
Begin
  Tag:=1;
  FillModelListBoxFromMasterList(BotModelComboBox.Items);
  Tag:=0;
  {load details of the last selected bot}
  Self.BotsListBoxClick(Sender);
End;

procedure TChildBotLibForm.Closelibrary1Click(Sender: TObject);
begin
Self.Close;
end;

procedure TChildBotLibForm.importasnewlistoptionClick(Sender: TObject);
begin
MainMenuForm.NewBotLibFromUTIniOptionClick(Sender);
end;

end.
