unit ModPresetBrowser;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, checklst, HyperLbl;

type
  TModPresetBrowserForm = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    EmailHyperlabel: THyperLabel;
    WWWHyperlabel: THyperLabel;
    AuthorLabel: TLabel;
    ModTitleLabel: TLabel;
    Label5: TLabel;
    OtherContactLabel: TLabel;
    DescriptionMemo: TMemo;
    Description: TLabel;
    ListBox1: TListBox;
    Label8: TLabel;
    ShowHeaderCB: TCheckBox;
    CheckListBox1: TCheckListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    OnlyExistingCB: TCheckBox;
    Label9: TLabel;
    Label7: TLabel;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    procedure CheckListBox1Click(Sender: TObject);
    procedure UpdateChecklist(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CheckListBox1ClickCheck(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ModPresetBrowserForm: TModPresetBrowserForm;

implementation

uses Knowledge,TModDetailsDefine, DatafileMaker;

{$R *.DFM}

procedure TModPresetBrowserForm.CheckListBox1Click(Sender: TObject);
var x:TModDetails;
begin
  if Checklistbox1.ItemIndex>-1 then
  begin
    x:=TModDetails(Checklistbox1.Items.Objects[Checklistbox1.ItemIndex]);
    ModTitleLabel.Caption:=x.Name;             
    DescriptionMemo.Lines.Text:=x.Description;
    AuthorLabel.Caption:=x.Author;
    EmailHyperLabel.Caption:=x.Email;
    EmailHyperLabel.URL:='mailto:'+x.Email;
    WWWHyperLabel.URL:=x.WWW;
    WWWHyperLabel.Caption:=x.WWW;
    OtherContactLabel.Caption:=x.OtherContact;
    Listbox1.Items.Text:=x.ServerPackages.Text;
  end;
end;

procedure TModPresetBrowserForm.UpdateChecklist(Sender: TObject);
var i:integer;  s:string;
begin
Checklistbox1.Clear;
if MasterModsList.Count>0 then
for i:=0 to MasterModsList.Count-1 do
  begin
    if ShowHeaderCB.Checked then
      s:='['+MasterModsList.Mods[i].TypeHeader+']: '+MasterModsList.Mods[i].Name
      else s:=MasterModsList.Mods[i].Name;
    if MasterModsList.Mods[i].IsInstalled OR (NOT OnlyExistingCB.Checked) then
      Checklistbox1.Items.AddObject(s,MasterModsList.Mods[i]);
  end;
Checklistbox1clickcheck(sender);
end;

procedure TModPresetBrowserForm.FormShow(Sender: TObject);
begin
UpdateChecklist(Sender);
ModTitleLabel.Caption:='';
DescriptionMemo.Lines.Text:='';
AuthorLabel.Caption:='';
EmailHyperlabel.Caption:='';
EmailHyperlabel.URL:='';
WWWHyperlabel.Caption:='';
WWWHyperlabel.URL:='';
OtherContactLabel.Caption:='';
Listbox1.Items.Text:='';
if Checklistbox1.Items.Count>0 then Checklistbox1.ItemIndex:=0
  else Checklistbox1.ItemIndex:=-1;
Checklistbox1Click(Self);
end;

procedure TModPresetBrowserForm.CheckListBox1ClickCheck(Sender: TObject);
var i,c:integer;
begin
c:=0;
BitBtn1.Enabled:=(c>0);
if Checklistbox1.Items.Count>0 then
  for i:=0 to Checklistbox1.Items.Count-1 do
    if CheckListBox1.Checked[i] then
      inc(c);
BitBtn1.Caption:='Add '+IntToStr(c)+' selected presets';
BitBtn1.Enabled:=(c>0);
end;

procedure TModPresetBrowserForm.BitBtn4Click(Sender: TObject);
begin
  {New datafile}
  DatafileWizard.CreateNew;
  DatafileWizard.ShowModal;
  Knowledge.LoadMasterList;
end;

procedure TModPresetBrowserForm.BitBtn3Click(Sender: TObject);
begin
  {Edit this datafile}
  if (CheckListBox1.ItemIndex>-1) then
  if (Checklistbox1.Items.Objects[Checklistbox1.ItemIndex] is TModDetails)
  then
  begin
  ShowMessage('Loading '+TModDetails(Checklistbox1.Items.Objects[Checklistbox1.ItemIndex]).UtscDatafile);
    DatafileWizard.LoadExisting(
       TModDetails(Checklistbox1.Items.Objects[Checklistbox1.ItemIndex])
       .UtscDatafile
       );
  end;
  DatafileWizard.ShowModal;
end;

procedure TModPresetBrowserForm.BitBtn2Click(Sender: TObject);
begin
Self.Close;
end;

end.

