{
This file is part of Unreal Tournament System Config version 210f.

Copyright (C) 2000, 2003 Simon McVittie.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit WeaponsFixer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Menus;

type
  TWeaponsPriorityFixer = class(TForm)
    ListBox1: TListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    ListBox2: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    Label5: TLabel;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    MainMenu1: TMainMenu;
    Help1: TMenuItem;
    AboutUTSC1: TMenuItem;
    Contents1: TMenuItem;
    N1: TMenuItem;
    Contextsensitivehelp1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FixPriorities(UserIni:string);
    procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure AddUTWeap(name:string);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure HelpContentsOptionClick(Sender: TObject);
    procedure HelpAboutOptionClick(Sender: TObject);
    procedure Contextsensitivehelp1Click(Sender: TObject);

  private
    { Private declarations }
    iFilename:string;
  public
    { Public declarations }
  end;

var
  WeaponsPriorityFixer: TWeaponsPriorityFixer;

const
  UTWeapons:array[0..13] of String=
                                        ('WarheadLauncher',
                                         'Translocator',
                                         'ImpactHammer',
                                         'ChainSaw',
                                         'Enforcer',
                                         'DoubleEnforcer',
                                         'UT_Biorifle',
                                         'ShockRifle',
                                         'PulseGun',
                                         'ripper',
                                         'Minigun2',
                                         'UT_FlakCannon',
                                         'UT_Eightball',
                                         'SniperRifle');

implementation
uses MainMenu,WeaponsPriorityFiles,About;

{$R *.DFM}

procedure TWeaponsPriorityFixer.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
Action:=caFree;
end;

procedure TWeaponsPriorityFixer.FixPriorities(UserIni:string);
var L:TStringList;
    i,j:integer;
    b:boolean;
Begin
 iFilename:=UserINI;
 Listbox1.Clear;
 Listbox2.Clear;
 L:=LoadWeapons(iFilename);
 try
   for j:=L.Count-1 downto 0 do
     begin
     b:=FALSE;
     for i:=0 to 13 do
       if uppercase(L[j]) = uppercase(UTWeapons[i]) then
       begin
         b:=TRUE;
         Listbox1.Items.Append(UTWeapons[i]);
       end;{for i}
     if NOT b then Listbox2.Items.Append(L[j]);
     end;{for j}
   for i:=13 downto 0 do
     if Listbox1.Items.IndexOf(UTWeapons[i])=-1
       then Listbox1.Items.Append(UTWeapons[i]);
 finally
 L.Free;
 end;{try}
End;

procedure TWeaponsPriorityFixer.BitBtn7Click(Sender: TObject);
begin
  {write weapons back to iFilename}
  SaveWeapons(iFilename,Listbox1.Items,Listbox2.Items);
  Self.Close;
end;

procedure TWeaponsPriorityFixer.BitBtn8Click(Sender: TObject);
begin
  Self.Close;
end;

procedure TWeaponsPriorityFixer.AddUTWeap(name:string);
var x:TStringList;
Begin
  x:=TStringList.Create;
  try
  x.Text:=Listbox1.Items.Text;
  if x.IndexOf(uppercase(name))<0 then Listbox1.Items.Append(name);
  finally
  x.Free;
  end;{try}
End;

procedure TWeaponsPriorityFixer.BitBtn1Click(Sender: TObject);
var s:string;
begin
if Listbox1.ItemIndex>0 then
  begin
    s:=Listbox1.Items[Listbox1.ItemIndex];
    Listbox1.Items[Listbox1.ItemIndex]:=Listbox1.Items[Listbox1.ItemIndex-1];
    Listbox1.Items[Listbox1.ItemIndex-1]:=s;
    Listbox1.ItemIndex:=Listbox1.ItemIndex-1;
  end;
end;

procedure TWeaponsPriorityFixer.BitBtn4Click(Sender: TObject);
var s:string;
begin
if Listbox2.ItemIndex>0 then
  begin
    s:=Listbox2.Items[Listbox2.ItemIndex];
    Listbox2.Items[Listbox2.ItemIndex]:=Listbox2.Items[Listbox2.ItemIndex-1];
    Listbox2.Items[Listbox2.ItemIndex-1]:=s;
        Listbox2.ItemIndex:=Listbox2.ItemIndex-1;
  end;
end;

procedure TWeaponsPriorityFixer.BitBtn2Click(Sender: TObject);
var s:string;
begin
if (Listbox1.ItemIndex>-1) AND (Listbox1.ItemIndex<Listbox1.Items.Count-1) then
  begin
    s:=Listbox1.Items[Listbox1.ItemIndex];
    Listbox1.Items[Listbox1.ItemIndex]:=Listbox1.Items[Listbox1.ItemIndex+1];
    Listbox1.Items[Listbox1.ItemIndex+1]:=s;
        Listbox1.ItemIndex:=Listbox1.ItemIndex+1;
  end;
end;

procedure TWeaponsPriorityFixer.BitBtn3Click(Sender: TObject);
var s:string;
begin
if (Listbox2.ItemIndex>-1) AND (Listbox2.ItemIndex<Listbox2.Items.Count-1) then
  begin
    s:=Listbox2.Items[Listbox2.ItemIndex];
    Listbox2.Items[Listbox2.ItemIndex]:=Listbox2.Items[Listbox2.ItemIndex+1];
    Listbox2.Items[Listbox2.ItemIndex+1]:=s;
        Listbox2.ItemIndex:=Listbox2.ItemIndex+1;
  end;
end;

procedure TWeaponsPriorityFixer.FormDestroy(Sender: TObject);
begin
MainMenuForm.WeaponsFixerOpen:=FALSE;
end;

procedure TWeaponsPriorityFixer.BitBtn6Click(Sender: TObject);
begin
if Listbox2.ItemIndex<>-1 then ListBox2.Items.Delete(Listbox2.ItemIndex);
end;

procedure TWeaponsPriorityFixer.BitBtn5Click(Sender: TObject);
begin
if MessageDlg('Delete all mod weapon priorities?',mtConfirmation,[mbYes,mbNo],0)
   = mrYes then Listbox2.Clear;
end;

procedure TWeaponsPriorityFixer.HelpContentsOptionClick(Sender: TObject);
Begin
MainMenuForm.HelpContentsoptionClick(Sender);
End;

procedure TWeaponsPriorityFixer.HelpAboutOptionClick(Sender: TObject);
Begin
MainMenuForm.HelpAboutOptionClick(Sender);
End;

procedure TWeaponsPriorityFixer.Contextsensitivehelp1Click(
  Sender: TObject);
begin
Aboutbox.GetHelp(helpPriority);
end;

end.
