!cd ../..

; To use this file, go to http://www.nullsoft.com and download NSIS 2 beta (open source, zlib license).
; Thanks to Justin Frankel at Nullsoft

!ifdef NO_COMPRESSION
SetCompress off
!else
SetDatablockOptimize on
!endif

Name "UTSC"
Caption "Unreal Tournament System Config v210f"
Icon "src\installer\main.ico"
OutFile utsc-210f-win32.exe

LicenseText "Conditions for copying and modification"
LicenseData COPYING.txt
ComponentText "This will install UTSC on your computer."
InstType Normal
InstType "Normal + Source Code"
DirShow show
AutoCloseWindow false
ShowInstDetails show
DirText "Please select a location to install UTSC (or use the default):"
SetOverwrite on
SetDateSave on

InstallDir $PROGRAMFILES\pseudorandom.co.uk\UTSC
InstallDirRegKey HKLM "Software\pseudorandom.co.uk\Paradox Productions\UTSC\version210" ""

Section "UTSC program and data (required)"
  SectionIn 1 2 RO
  SetOutPath $INSTDIR
  WriteUninstaller uninstall.exe
  File "Advanced Model Support v110 by Simon _Psychic_313_ McVittie.utsc.txt"
  File COPYING.txt
  File UTSC.exe
  File utsc210.dat
SectionEnd

Section "HTML documentation"
  SectionIn 1 2
  SetOutPath $INSTDIR
  File makedata.htm
  File manualintro.htm
  File options.htm
  File serverpackages.htm
  File botlib.htm
  File bugs.htm
  File faq.htm
  File help.htm
  File inst.htm
  File legal.htm
  File utscdata.htm
SectionEnd

Section "Start menu group"
  SectionIn 1 2
  SetOutPath "$SMPROGRAMS\UT System Config"
  CreateShortCut "$SMPROGRAMS\UT System Config\UT System Config.lnk" \
                 "$INSTDIR\UTSC.exe"
  CreateShortCut "$SMPROGRAMS\UT System Config\Documentation.lnk" \
                 "$INSTDIR\help.htm"
  CreateShortCut "$SMPROGRAMS\UT System Config\Website.lnk" \
                 "http://www.pseudorandom.co.uk/2000/utsc/"
  CreateShortCut "$SMPROGRAMS\UT System Config\Uninstall.lnk" \
                 "$INSTDIR\uninstall.exe"
SectionEnd

Section "Source code (needs Delphi 3)"
  SectionIn 2
  SetOutPath $INSTDIR
  File hacking.txt
  SetOutPath $INSTDIR\src\ModData
  File src\ModData\*.*
  SetOutPath $INSTDIR\src\Innards
  File src\Innards\*.pas
  SetOutPath $INSTDIR\src\SharedUtils
  File src\SharedUtils\*.pas
  SetOutPath $INSTDIR\src\UI
  File src\UI\*.pas
  File src\UI\*.dfm
  SetOutPath $INSTDIR\src
  File /r src\installer
  File src\*.pas
  File src\*.dof
  File src\*.res
  File src\*.dpr
  File src\*.dfm
SectionEnd

Section -post
  WriteRegStr HKLM "Software\pseudorandom.co.uk\Paradox Productions\UTSC\version210" "" $INSTDIR
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\UTSystemConfig210" \
                   "DisplayName" "Unreal Tournament System Config v210f (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\UTSystemConfig210" \
                   "UninstallString" '"$INSTDIR\uninstall.exe"'
SectionEnd

UninstallText "This will uninstall UTSC from your system."
UninstallIcon src\installer\uninst.ico

Section Uninstall
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\UTSystemConfig210"
  DeleteRegKey HKLM "Software\pseudorandom.co.uk\Paradox Productions\UTSC\version210"
  Delete "$INSTDIR\Advanced Model Support v110 by Simon _Psychic_313_ McVittie.utsc.txt"
  Delete $INSTDIR\COPYING.txt
  Delete $INSTDIR\UTSC.exe
  Delete $INSTDIR\botlib.htm
  Delete $INSTDIR\bugs.htm
  Delete $INSTDIR\faq.htm
  Delete $INSTDIR\hacking.txt
  Delete $INSTDIR\help.htm
  Delete $INSTDIR\inst.htm
  Delete $INSTDIR\legal.htm
  Delete $INSTDIR\makedata.htm
  Delete $INSTDIR\manualintro.htm
  Delete $INSTDIR\options.htm
  Delete $INSTDIR\serverpackages.htm
  Delete $INSTDIR\utsc210.dat
  Delete $INSTDIR\utscdata.htm
  Delete $INSTDIR\uninstall.exe
  RMDir /r $INSTDIR\src
  RMDir $INSTDIR
  RMDir /r "$SMPROGRAMS\UT System Config"

  ; if $INSTDIR was removed, skip these next ones
  IfFileExists $INSTDIR 0 Removed 
    MessageBox MB_YESNO|MB_ICONQUESTION \
      "Remove all files in your UTSC directory? (If you have anything \
 you created that you want to keep, click No)" IDNO Removed
    Delete $INSTDIR\*.* ; this would be skipped if the user hits no
    RMDir /r $INSTDIR
    IfFileExists $INSTDIR 0 Removed 
      MessageBox MB_OK|MB_ICONEXCLAMATION \
                 "Note: $INSTDIR could not be removed."
  Removed:
SectionEnd
